#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

ll solve(vector<ll> a)
{
    int n = a.size();
    bool f1 = 0, f2 = 0;
    for(int i = 0; i < n; i++)
    {
        f1 |= (a[i] < 0);
        f2 |= (a[i] > 0);
    }
    ll ans = LONG_LONG_MAX;

    ll m1 = a[n - 1];
    for(int i = n - 2; i >= 0; i--)
    {
        if(a[i] < m1)
        {
            ans = min(ans, a[i] * m1);
        }
        else m1 = a[i];
    }
    vector<ll> u(n);
    u[0] = a[0];
    for(int i = 1; i < n; i++)
    {
        u[i] = min(u[i - 1], a[i]);
    }
    for(int i = 1; i < n; i++)
    {
        if(u[i - 1] < a[i])
        {
            ans = min(ans, u[i - 1] * a[i]);
        }
    }
    return ans;
}

ll slow_solve(vector<ll> a)
{
    ll ans = LONG_LONG_MAX;
    for(int i = 0; i < a.size(); i++)
    {
        for(int j = 0; j < a.size(); j++)
        {
            if(i < j && a[i] < a[j]) ans = min(ans, a[i] * a[j]);
        }
    }
    return ans;
}

void stress()
{
    while(true)
    {
        int n = 5;
        vector<ll> v(n);
        for(int i = 0; i < n; i++)
        {
            v[i] = rand() % 20 - 10;
        }
        if(solve(v) != slow_solve(v))
        {
            for(int i : v) cout << i << " "; cout << endl;
            cout << solve(v) << " " << slow_solve(v) << endl;
            break;
        }
        cout << "YES" << endl;
    }
}

void get_ac()
{
    int t;
    cin >> t;
    for(int test = 0; test < t; test++)
    {
        ll n, l, r, x, y, z, b1, b2;
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
        vector<ll> b(n), a(n);
        b[0] = b1;
        b[1] = b2;
        for(int i = 2; i < n; i++)
        {
            b[i] = (b[i - 2] * x + b[i - 1] * y + z) & ((1LL << 32) - 1);
        }
        for(int i = 0; i < n; i++)
        {
            a[i] = (b[i] % (r - l + 1)) + l;
        }
        ll ans = solve(a);
        if(ans == LONG_LONG_MAX) cout << "IMPOSSIBLE" << endl;
        else cout << ans << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    cout.precision(0); cout << fixed;
    get_ac();
}


/*
2
4 -5 5 11 13 17 0 3
5 0 100 0 1 0 42 42


*/
