#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <iomanip>
#include <string>
std::vector<int> zfunction(std::string s)
{
	int n = (int)s.length();
	std::vector<int> z(n);
	for (int i = 1, l = 0, r = 0; i < n; i++)
	{
		if (i <= r)
			z[i] = std::min(r - i + 1, z[i - l]);
		while (i + z[i] < n && s[z[i]] == s[i + z[i]])
			++z[i];
		if (i + z[i] - 1 > r) l = i, r = i + z[i] - 1;
	}
	return z;
}
typedef unsigned int uint;
int main(int argc, char*argv[])
{
	std::string s;
	while (true)
	{
		std::string line;
		std::getline(std::cin, line);
		if (line == "\\begin{thebibliography}{99}") break;
		s += line;
	}
	auto zsearch1 = zfunction("\\cite{$" + s);
	std::vector < std::string> sources;
	std::map<std::string, std::string> descriptions;
	for (size_t i = 1; i < zsearch1.size(); i++)
	{
		int sind = zsearch1[i];
		if (sind > 5)
		{
			std::string name;
			int ind = i - 1;
			while (s[ind] != '}') name += s[ind++];
			std::cout << name << " is found!\n";
			sources.push_back(name);
		}
	}
	int cur = 0;
	bool bad = false;
	while (true)
	{
		std::string line;
		std::getline(std::cin, line);
		if (line == "\\end{thebibliography}") break;
		int sind = 9;
		std::string name, desc;
		while (line[sind] != '}') name += line[sind++];
		std::cout << name << " is refound!";
		if (name != sources[cur++]) bad = true;
		while (sind != line.size())
			desc += line[sind++];
		descriptions[name] = desc;
	}
	if (!bad)
	{
		std::cout << "Correct"; return 0;
	}
	std::cout << "Incorrect\n";
	std::cout << "\\begin{thebibliography}{99}\n";
	for (size_t i = 0; i < sources.size(); i++)
	{
		std::cout << "\\bibitem{" << sources[i] << "}" << descriptions[sources[i]].substr(1) << "\n";
	}
	std::cout << "\\end{thebibliography}";
	return 0;
}