from copy import deepcopy
mobs = list()


# dt - death turn
# a - attack
# h - health


def new_mob():
    mobs.append({'a': 1, 'h': 1, 'dt': None})


def attack_up(i):
    if mobs[i]['h'] > 0:
        mobs[i]['a'] *= 2


def health_up(i):
    if mobs[i]['h'] > 0:
        mobs[i]['h'] *= 2


def copy(i, turns_count):
    new_mob = deepcopy(mobs[i])

    if mobs[i]['h'] <= 0:
        new_mob['dt'] = turns_count

    mobs.append(new_mob)


def battle(i, j, turns_count):
    if mobs[i]['h'] <= 0 or mobs[j]['h'] <= 0:
        return

    mobs[i]['h'] -= mobs[j]['a']
    mobs[j]['h'] -= mobs[i]['a']

    if mobs[i]['h'] <= 0:
        mobs[i]['dt'] = turns_count
    if mobs[j]['h'] <= 0:
        mobs[j]['dt'] = turns_count


def process():
    turns_count = 1
    n = int(input())

    for _ in range(n):
        data = list(map(int, input().split()))

        if data[0] == 1:
            new_mob()

        elif data[0] == 2:
            attack_up(data[1] - 1)

        elif data[0] == 3:
            health_up(data[1] - 1)

        elif data[0] == 4:
            copy(data[1] - 1, turns_count)

        else:
            battle(data[1] - 1, data[2] - 1, turns_count)

        turns_count += 1


process()
print(len(mobs))

for mob in mobs:
    print(f"{'-1' if mob['h'] > 0 else mob['dt']}", end=' ')
