#include <iostream>
#include <vector>
#include <string>

using namespace std;

struct Reference {
    string key, description;
};

void print_ref(vector<Reference> &ref, string &_max) {
    cout << "\\begin{thebibliography}{" << _max << "}" << endl;
    for(auto r : ref) {
        cout << "\\bibitem{" << r.key << "}" << r.description << endl;
    }
    cout << "\\end{thebibliography}" << endl;
}

void correct_ref(vector<string> &occurs, vector<Reference> &ref, string &_max) {
    cout << "Incorrect" << endl;
    vector<Reference> correct;
    for(const auto o : occurs) {
        for(auto r : ref) {
            if(r.key == o) {
                correct.push_back(r);
                break;
            }
        }
    }
    print_ref(correct, _max);
}

int main() {
    ios_base::sync_with_stdio(false);
    string in;
    vector<string> occurs;
    vector<Reference> ref;
    string _max;
    while(cin >> in) {
        if(in.find("\\cite{") == 0) {
            string c;
            for(unsigned long long i = 6; i < in.find('}'); i++)
                c += in[i];
            occurs.push_back(c);
        } else if(in.find("\\begin{thebibliography}{") == 0) {
            for(unsigned long long i = 24; i < in.size() - 1; i++) {
                _max += in[i];
            }
            break;
        }
    }
    while(cin >> in) {
        if(in.find("\\end{thebibliography}") == 0) {
            break;
        }
        if(in.find("\\bibitem{") == 0) {
            string key;
            for(unsigned long long i = 9; i < in.size() - 1; i++) {
                key += in[i];
            }
            string desc;
            getline(cin, desc);
            ref.push_back(Reference {
                    key, desc
            });
        } else {
            string desc;
            getline(cin, desc);
            ref[ref.size()-1].description += "\n" + in + desc;
        }
    }
    for(int i = 0; i < ref.size(); i++) {
        if(ref[i].key != occurs[i]) {
            correct_ref(occurs, ref, _max);
            return 0;
        }
    }
    cout << "Correct" << endl;
    return 0;
}