#include <iostream>
#include <map>
#include <vector>

using namespace std;

struct Creature {
    long double a = 1, h = 1;
    bool dead = false;
    long long died_at = -1;
};

long long turn = 0, last_creature = -1;
vector<Creature> c;

void summon() {
    last_creature++;
    c[last_creature] = Creature{};
}

void buff_atk(long long id) {
    if(c[id].dead)
        return;
    c[id].a *= 2;
}

void buff_hp(long long id) {
    if(c[id].dead)
        return;
    c[id].h *= 2;
}

void clone(long long id) {
    last_creature++;
    c[last_creature] = c[id];
    if(c[last_creature].dead)
        c[last_creature].died_at = turn;
}

void fight(long long id1, long long id2) {
    if(c[id1].dead || c[id2].dead)
        return;
    if(c[id1].h <= c[id2].a) {
        c[id1].dead = true;
        c[id1].died_at = turn;
    } else {
        c[id1].h -= c[id2].a;
    }

    if(c[id2].h <= c[id1].a) {
        c[id2].dead = true;
        c[id2].died_at = turn;
    } else {
        c[id2].h -= c[id1].a;
    }
}

void print_deaths() {
    cout << last_creature+1 << endl;
    for(int i = 0; i <= last_creature; i++) {
        cout << c[i].died_at << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    long long n;
    int cmd;
    cin >> n;
    c = vector<Creature>((unsigned long long)n);
    long long id, id1, id2;
    for(long long i = 0; i < n; i++) {
        turn++;
        cin >> cmd;
        switch(cmd) {
            case 1:
                summon();
                break;
            case 2:
                cin >> id;
                buff_atk(id-1);
                break;
            case 3:
                cin >> id;
                buff_hp(id-1);
                break;
            case 4:
                cin >> id;
                clone(id-1);
                break;
            case 5:
                cin >> id1 >> id2;
                fight(id1-1, id2-1);
                break;
            default:
                break;
        }
    }
    print_deaths();
    return 0;
}