import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class TaskB {
    
    private static final String BEGIN = "\\begin{thebibliography}";
    private static final String END = "\\end{thebibliography}";
    
    private static final Pattern pattern = Pattern.compile("\\\\cite\\{.*?}");
    
    public static void main(String[] args) throws Exception {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        
        boolean links = false;
        ArrayList<String> references = new ArrayList<>(100);
        
        ArrayList<String> list = new ArrayList<>(100);
        HashMap<String, String> map = new HashMap<>();
        
        String s;
        while((s = in.readLine()) != null) {
            if(s.startsWith(BEGIN)) links = true;
            if(s.startsWith(END)) break;
            
            if(!links) {
                Matcher m = pattern.matcher(s);
                while(m.find()) references.add(getKey(m.group()));
            } else {
                if(s.startsWith("\\bibitem")) {
                    String key = getKey(s);
                    
                    list.add(key);
                    map.put(key, s);
                }
            }
        }
        
        if(list.equals(references)) {
            System.out.println("Correct");
        } else {
            System.out.println("Incorrect");
            System.out.println(BEGIN);
            for(String key : references) System.out.println(map.get(key));
            System.out.println(END);
        }
    }
    
    private static String getKey(String g) {
        g = g.substring(g.indexOf('{') + 1);
        return g.substring(0, g.indexOf('}')); 
    }
    
}
