#define M_E        2.71828182845904523536   // e
#define M_LOG2E    1.44269504088896340736   // log2(e)
#define M_LOG10E   0.434294481903251827651  // log10(e)
#define M_LN2      0.693147180559945309417  // ln(2)
#define M_LN10     2.30258509299404568402   // ln(10)
#define M_PI       3.14159265358979323846   // pi
#define M_PI_2     1.57079632679489661923   // pi/2
#define M_PI_4     0.785398163397448309616  // pi/4
#define M_1_PI     0.318309886183790671538  // 1/pi
#define M_2_PI     0.636619772367581343076  // 2/pi
#define M_2_SQRTPI 1.12837916709551257390   // 2/sqrt(pi)
#define M_SQRT2    1.41421356237309504880   // sqrt(2)
#define M_SQRT1_2  0.707106781186547524401  // 1/sqrt(2)
#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <future>

using namespace std;

#define IN_FILE "in.txt"
#define OUT_FILE "out.txt"

#define EPS 1e-6
#define INF 1e18
#define SMALL_INF 1e9

#pragma warning (disable : 4996)

vector<long long> a;
vector<unsigned long long> b;

const long long MOD = 1LL << 32;

int main()
{
#ifdef  _DEBUG
	freopen(IN_FILE, "r", stdin);
	freopen(OUT_FILE, "w", stdout);
#endif
	int t;
	cin >> t;
	while (t--)
	{
		int n;
		long long l, r, x, y, z, b1, b2;
		scanf("%d%lld%lld%lld%lld%lld%lld%lld", &n, &l, &r, &x, &y, &z, &b1, &b2);
		b.resize(n);
		a.resize(n);
		b[0] = b1;
		b[1] = b2;
		for (int i =  2; i < n; i++)
		{
			b[i] = (b[i - 2] * x + b[i - 1] * y + z) % MOD;
		}
		bool zero = false;
		for (int i = 0; i < n; i++)
		{
			a[i] = b[i] % (r - l + 1) + l;
			if (a[i] == 0)
				zero = true;
		}
		long long minNeg = INF, minAbs1 = INF, minAbs2 = INF, maxPos = -INF;
#ifdef _DEBUG
		for (auto val : b)
		{
			cout << val << " ";
		}
		cout << endl;
		for (auto val : a)
		{
			cout << val << " ";
		}
		cout << endl;
#endif
		for (int i = 0; i < n; i++)
		{
			if (a[i] == 0)
				continue;
			if (a[i] < 0)
			{
				minNeg = min(minNeg, a[i]);
			} else 
			{
				maxPos = max(maxPos, a[i]);
			}
			if (abs(a[i]) < abs(minAbs1) || minAbs1 == INF)
			{
				minAbs2 = minAbs1;
				minAbs1 = a[i];
			} else if ((abs(a[i]) < abs(minAbs2) || minAbs2 == INF) && abs(a[i]) != abs(minAbs1))
			{
				minAbs2 = a[i];
			}
		}
#ifdef _DEBUG
		cout << minNeg << " " << minAbs1 << " " << minAbs2 << " " << maxPos << endl;
#endif
		long long res = INF;
		if (zero)
			res = 0;
		if (minNeg != INF && maxPos != -INF)
		{
			res = min(res, minNeg * maxPos);
		} else
		{
			if (minAbs1 != INF && minAbs2 != INF)
			{
				res = min(res, minAbs1 * minAbs2);
			} 
		}
		if (res == INF)
			cout << "IMPOSSIBLE\n";
		else
			cout << res << endl;
	}
	return 0;
}

