import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.*;

public class TaskK {
    
    public static void main(String[] args) throws Exception {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(in.readLine());
        
        ArrayList<Mind> list = new ArrayList<>();
        for(int i = 0; i < n; i++) {
            String[] data = in.readLine().split(" ");
            list.add(new Mind(i + 1, data[0], data[1]));
        }

        Collections.sort(list);

        ArrayList<ArrayList<Mind>> initial = new ArrayList<>();
        for(int i = 0; i < list.size(); i++) {
            ArrayList<Mind> cur = new ArrayList<>();
            cur.add(list.get(i));

            for(int j = i + 1; j < list.size(); j++) {
                if(!Mind.isAinB(list.get(i), list.get(j)) || !Mind.isAinB(list.get(j), list.get(i))) break;
                i = j;
                cur.add(list.get(j));
            }

            initial.add(cur);
        }
        
        HashMap<Integer, ArrayList<ArrayList<Mind>>> map = new HashMap<>();
        for(ArrayList<Mind> l : initial) {
            int hashCode = l.get(0).hashCode();
            map.computeIfAbsent(hashCode, (e) -> new ArrayList<>()).add(l);
        }
        
        ArrayList<ArrayList<Mind>> answer = new ArrayList<>();
        for(ArrayList<ArrayList<Mind>> group : map.values()) {
            for(int i = 0; i < group.size(); i++) {
                for(int j = 0; j < group.size(); j++) {
                    if(i == j) continue;
                    
                    ArrayList<Mind> a = group.get(i);
                    ArrayList<Mind> b = group.get(j);
                    
                    if(a.size() == 0 || b.size() == 0) continue;
                    
                    if(a.get(0).compareTo(b.get(0)) == 0) {
                        a.addAll(b);
                        b.clear();
                    }
                }
            }
            
            for(ArrayList<Mind> g : group) if(g.size() != 0) answer.add(g);
        }

        System.out.println(answer.size());
        for(ArrayList<Mind> cur : answer) {
            System.out.print(cur.size());
            for(Mind a : cur) System.out.print(" " + a.index);
            System.out.println();
        }
    }
    
    public static class Mind implements Comparable<Mind> {
        
        private final int index;
        private final char[] prefix, suffixArr;
        private final BitSet suffix, allBits;
        
        private final String stringRepresentation;
        
        public Mind(int index, String prefix, String suffix) {
            this.index = index;
            
            this.prefix = prefix.toCharArray();
            this.suffixArr = suffix.toCharArray();
            
            this.suffix = new BitSet(26);
            for(int i = 0; i < suffix.length(); i++) this.suffix.set(suffix.charAt(i) - 'a');
            
            this.allBits = (BitSet)this.suffix.clone();
            for(int i = 0; i < prefix.length(); i++) this.allBits.set(prefix.charAt(i) - 'a');
            
            this.stringRepresentation = "{" + prefix + " " + suffix + "}";
        }
        
        @Override
        public int hashCode() {
            return Objects.hash(allBits, suffix);
        }
        
        @Override
        public String toString() {
            return stringRepresentation;
        }
        
        @Override
        public int compareTo(Mind o) {
            boolean a = isAinB(this, o), b = isAinB(o, this);
            
            if(a && b) return 0;
            
            if(a) return 1;
            if(b) return -1;
            
            for(int i = 0; ; i++) {
                int val = Character.compare(this.ithChar(i), o.ithChar(i));
                if(val != 0) return val;
            }
        }
        
        public char ithChar(int i) {
            if(i < prefix.length) return prefix[i];
            return suffixArr[(i - prefix.length) % suffixArr.length];
        }
        
        public static boolean isAinB(Mind a, Mind b) {
            int ptr = 0, i;
            for(i = 0; i < a.prefix.length; i++) {
                while(ptr < b.prefix.length && b.prefix[ptr] != a.prefix[i]) ptr++;
                
                if(ptr == b.prefix.length) break;
                ptr++;
            }
            
            BitSet bits = (BitSet)a.suffix.clone();
            for(; i < a.prefix.length; i++) bits.set(a.prefix[i] - 'a');
            
            BitSet and = ((BitSet)bits.clone());
            and.and(b.suffix);
            
            return and.equals(bits);
        }
        
    }
    
}
