#include <bits/stdc++.h>

using namespace std;

struct tree
{
	tree *l, *r;
	char mx;
	char upd;
	tree(char mx, char upd, tree *l, tree *r): mx(mx), upd(upd), l(l), r(r)
	{
	}
	tree()
	{
	}
};

tree *ch(tree *t, int x)
{
	return new tree(t->mx + x, t->upd + x, t->l, t->r);
}

tree *upd(tree *t, int l, int r, int tl, int tr, int x)
{
	if (tl >= r || tr <= l)
	{
		return t;
	}
	if (tl >= l && tr <= r)
	{
		return ch(t, x);
	}
	else
	{
		int tm = (tl + tr) / 2;
		tree *go = new tree(t->mx, t->upd, t->l, t->r);
		if (!go->l) go->l = new tree(0, 0, 0, 0);
		if (!go->r) go->r = new tree(0, 0, 0, 0);
		go->l = upd(go->l, l, r, tl, tm, x);
		go->r = upd(go->r, l, r, tm, tr, x);
		go->mx = max(go->l->mx, go->r->mx) + go->upd;
		return go;
	}
}

int get(tree *t, int l, int r, int tl, int tr, int s = 0)
{
	if (tl >= r || tr <= l)
	{
		return 0;
	}
	if (!t)
	{
		return s;
	}
	if (tl >= l && tr <= r)
	{
		return t->mx + s;
	}
	else
	{
		int tm = (tl + tr) / 2;
		return max(get(t->l, l, r, tl, tm, s + t->upd), get(t->r, l, r, tm, tr, s + t->upd));
	}
}

tree *vl(tree *t)
{
	if (!t) return 0;
	else return t->l;
}

tree *vr(tree *t)
{
	if (!t) return 0;
	else return t->r;
}


const int inf = 5e5;

int fnd(tree *t, int l, int r, int tl, int tr, int s = 0)
{
	if (tl >= r || tr <= l || (!t && !s) || (t && !(t->mx + s)))
	{
		return -inf;
	}
	if (tr - tl == 1)
	{
		return tl;
	}
	else
	{
		int tm = (tl + tr) / 2;
		if (t) s += t->upd;
		int x = fnd(vl(t), l, r, tl, tm, s);
		if (x == -inf)
		{
			return fnd(vr(t), l, r, tm, tr, s);
		}
		else
		{
			return x;
		}
	}
}


struct num
{
	int shift;
	tree *vert;
	bool pos;
	num()
	{
		vert = new tree(0, 0, 0, 0);
		pos = 0;
		shift = 0;
		vert = upd(vert, 0, 1, -inf, inf, 1);
	}
};

struct chel
{
	bool dead;
	int at;
	num health;
	chel(int at, num health): at(at), health(health), dead(false)
	{
	}
};

num copy(num x)
{
	return x;
}

num dbl(num x)
{
	x.shift++;
	return x;
}

num sub(num x, int at)
{
	at -= x.shift;
	int ret = fnd(x.vert, at, inf, -inf, inf);
	if (ret == -inf)
	{
		x.pos = 1;
	}
	else
	{
		x.vert = upd(x.vert, at, ret, -inf, inf, 1);
		x.vert = upd(x.vert, ret, ret + 1, -inf, inf, -1);
		if (!x.vert->mx)
		{
			x.pos = 1;
		}
	}
	return x;
}

bool notpos(num x)
{
	return x.pos;
}

int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	vector<chel> chels;
	vector<int> ansich(n, -2);
	for (int i = 0; i < n; ++i)
	{
		int t;
		cin >> t;
		if (t == 1)
		{
			num mem = num();
			chels.push_back({0, mem});
		}
		if (t == 2)
		{
			int x;
			cin >> x;
			--x;
			if (chels[x].dead)
				continue;
			chels[x].at++;
		}
		if (t == 3)
		{
			int x;
			cin >> x;
			--x;
			if (chels[x].dead)
				continue;
			chels[x].health = dbl(chels[x].health);
		}
		if (t == 4)
		{
			int x;
			cin >> x;
			--x;
			if (chels[x].dead)
			{
				ansich[chels.size()] = i;
				chels.push_back(chels[x]);
				continue;
			}
			num mem = copy(chels[x].health);
			chels.push_back({chels[x].at, mem});
		}
		if (t == 5)
		{
			int x, y;
			cin >> x >> y;
			--x, --y;
			if (chels[x].dead || chels[y].dead)
				continue;
			chels[y].health = sub(chels[y].health, chels[x].at);
			chels[x].health = sub(chels[x].health, chels[y].at);
			if (notpos(chels[x].health))
			{
				chels[x].dead = true;
				ansich[x] = i;
			}
			if (notpos(chels[y].health))
			{
				chels[y].dead = true;
				ansich[y] = i;
			}
		}
		/*
		for (int i = 0; i < (int) chels.size(); i++)
		{
			cout << chels[i].at << ' '; 
		}
		cout << '\n';
		*/
	}
	cout << chels.size() << '\n';
	for (int i = 0; i < (int) chels.size(); i++) cout << ansich[i] + 1 << ' ';
	cout << '\n';
}
