#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define F first
#define S second
#define M make_pair

#define endl "\n"

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

const int inf = 2e9 + 27;
const int mod = 1e9 + 123;
const ll p = 265;

int n, mask[100005], d[100005], len[100005], curMask[100005];
ll power[100005];
string s[100005], t[100005];
vector <int> groups[100005];
map <int, map <int, int>> used[100005];

void unite(int a, int b);
int get(int a);
int getMask(string &s);


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	power[0] = 1;
	
	for (int i = 1; i <= 100000; i++)
		power[i] = power[i - 1] * p % mod;
	
	cin >> n;
	
	for (int i = 1; i <= n; i++) {
		d[i] = i;
		len[i] = 1;
	}
	
	for (int i = 1; i <= n; i++) {
		cin >> s[i] >> t[i];
		
		mask[i] = getMask(t[i]);
		
		curMask[t[i].size()] = 0;
		
		for (int j = t[i].size() - 1; j > -1; j--)
			curMask[j] = curMask[j + 1] | (1 << (t[i][j] - 'a'));
		
		ll h = 0;
		int m = 0;
	
		for (int pref = 0; pref <= s[i].size(); pref++) {
			if ((curMask[pref] & mask[i]) == curMask[pref]) {
				auto it = used[pref].find(h);
			
				if (it != used[pref].end()) {
					auto jt = it->second.find(mask[i]);
					
					if (jt != it->second.end()) {
						unite(jt->second, i);
					}
				}
				
				used[pref][h][mask[i]] = i;
			}
			
			if (pref < s[i].size()) {
				h = (h * p + s[i][pref]) % mod;
				m |= 1 << (s[i][pref] - 'a');
			}
		}
	}
	
	for (int i = 1; i <= n; i++)
		groups[get(i)].push_back(i);
	
	int cnt = 0;
	
	for (int i = 1; i <= n; i++) {
		if (!groups[i].empty())
			cnt++;
	}
	
	cout << cnt << endl;
	
	for (int i = 1; i <= n; i++) {
		if (groups[i].empty())
			continue;
		
		cout << groups[i].size() << " ";
		
		for (auto it : groups[i])
			cout << it << " ";
		cout << endl;
	}

	return 0;
}

void unite(int a, int b) {
	a = get(a);
	b = get(b);
	
	if (a == b)
		return;
	
	if (len[a] < len[b])
		swap(a, b);
	
	len[a] += len[b];
	d[b] = a;
}

int get(int a) {
	if (d[a] != a)
		d[a] = get(d[a]);
	
	return d[a];
}

int getMask(string &s) {
	int result = 0;
	
	for (auto it : s)
		result |= 1 << (it - 'a');
	
	return result;
}
