#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define F first
#define S second
#define M make_pair

#define endl "\n"

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

const int inf = 2e9 + 27;
const int mod1 = 1e9 + 123;
const int mod2 = 1e9 + 7;
const ll p1 = 265;
const ll p2 = 367;

int n, mask[100005], d[100005], len[100005], curMask[100005];
ll power1[100005], power2[100005];
string s[100005], t[100005];
map <int, vector <int>> groups;
set <tuple <int, int, int, int>> used[100005];

void unite(int a, int b);
int get(int a);
int getMask(string &s);


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	power1[0] = power2[0] = 1;
	
	for (int i = 1; i <= 100000; i++) {
		power1[i] = power1[i - 1] * p1 % mod1;
		power2[i] = power2[i - 1] * p2 % mod2;
	}
	
	cin >> n;
	
	for (int i = 1; i <= n; i++) {
		d[i] = i;
		len[i] = 1;
	}
	
	for (int i = 1; i <= n; i++) {
		cin >> s[i] >> t[i];
		
		mask[i] = getMask(t[i]);
		
		curMask[t[i].size()] = 0;
		
		for (int j = t[i].size() - 1; j > -1; j--)
			curMask[j] = curMask[j + 1] | (1 << (t[i][j] - 'a'));
		
		ll h1 = 0, h2 = 0;
		int m = 0;
	
		for (int pref = 0; pref <= s[i].size(); pref++) {
			if ((curMask[pref] & mask[i]) == curMask[pref]) {
				auto it = used[pref].lower_bound({h1, h2, mask[i], 0});
			
				if (it != used[pref].end()) {
					int a, b, c, d, e;
					a = get<0>(*it);
					b = get<1>(*it);
					c = get<2>(*it);
					d = get<3>(*it);
					
					if ((a == h1) && (b == h2) && (c == mask[i])) {
						unite(d, i);
					}
				}
				
				used[pref].insert(make_tuple(h1, h2, mask[i], i));
			}
			
			if (pref < s[i].size()) {
				h1 = (h1 * p1 + s[i][pref]) % mod1;
				h2 = (h2 * p2 + s[i][pref]) % mod2;
			}
		}
	}
	
	for (int i = 1; i <= n; i++)
		groups[get(i)].push_back(i);
	
	cout << groups.size() << endl;
	
	for (auto it : groups) {
		cout << it.second.size() << " ";
		
		for (auto it : it.second)
			cout << it << " ";
		cout << endl;
	}

	return 0;
}

void unite(int a, int b) {
	a = get(a);
	b = get(b);
	
	if (a == b)
		return;
	
	if (len[a] < len[b])
		swap(a, b);
	
	len[a] += len[b];
	d[b] = a;
}

int get(int a) {
	if (d[a] != a)
		d[a] = get(d[a]);
	
	return d[a];
}

int getMask(string &s) {
	int result = 0;
	
	for (auto it : s)
		result |= 1 << (it - 'a');
	
	return result;
}
