#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define len(v) ((int)v.size())
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef pair<string, string> pss;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &x : v) {
        is >> x;
    }
    return is;
}


template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
    for (const T &x : v) {
        os << x << " ";
    }
    return os;
}


void run();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("latex.txt", "r", stdin);
    run();
}

string text;

string get_substr(int l, int r) {
    r = min(r, len(text));
    if (l >= r) return "";
    return string(text.begin() + l, text.begin() + r);
}

const string cite = "\\cite";
const string lbegin = "\\begin";
const string litem = "\\bibitem";
const string lend = "\\end";

string extract(int i, char stop) {
    string rez = "";
    while (text[i] != stop) {
        rez += text[i];
        i++;
    }
    return rez;
}

void solve() {
    vector<string> order;
    vector<pss> cur;
    int i = 0;
    while (i < len(text)) {
        if (get_substr(i, i + len(cite)) == cite) {
            string href = extract(i + len(cite) + 1, '}');
            order.pb(href);
            i += len(cite) + 1;
        } else if (get_substr(i, i + len(lbegin)) == lbegin) {
            i++;
        } else if (get_substr(i, i + len(litem)) == litem) {
            string href = extract(i + len(litem) + 1, '}');
            string content = extract(i + len(litem) + 2 + len(href), '\\');
            cur.emplace_back(href, content);
            i += len(litem) + len(href) + 2 + len(content);
        } else {
            i += 1;
        }
    }

    bool fail = false;
    for (int i = 0; i < len(order); i++) {
        if (order[i] != cur[i].first) {
            fail = true;
        }
    }
    if (fail) {
        cout << "Incorrect" << endl;
    } else {
        cout << "Correct" << endl;
        return;
    }
    map<string, string> _m(cur.begin(), cur.end());
    cout << "\\begin{thebibliography}{99}" << endl;
    for (string s : order) {
        cout << "\\bibitem{" + s + "}" + _m[s];
    }
    cout << "\\end{thebibliography}" << endl;
}

void run() {
    string s = "";
    while (getline(cin, s)) {
        text += s + "\n";
    }
    solve();
}


