#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include<tuple>
#include<map>

using namespace std;

typedef long long ll;
typedef long double ld;

vector <vector <bool>> p(8, vector <bool>(8, false)), u(8, vector <bool>(8, false));
int g[8][8][8][8];
pair <int, int> opt[8][8][8][8];
vector <pair <int, int>> path;
vector <string> ans;


inline bool c(int a, int b) {
	if (a >= 0 && a < 8 && b >= 0 && b < 8)
		return true;
	else return false;
}

void make_graph() {
	for (int x1 = 0; x1 < 8; x1++) {
		for (int y1 = 0; y1 < 8; y1++) {
			for (int x2 = 0; x2 < 8; x2++) {
				for (int y2 = 0; y2 < 8; y2++) {
					opt[x1][y1][x2][y2] = make_pair(-1, -1);
					g[x1][y1][x2][y2] = 1e6;
				}
			}
		}
	}
	for (int i = 0; i < 8; i++) {
		for (int j = 0; j < 8; j++) {
			if (c(i + 1, j + 2)) g[i][j][i + 1][j + 2] = 1;
			if (c(i + 1, j - 2)) g[i][j][i + 1][j - 2] = 1;
			if (c(i - 1, j + 2)) g[i][j][i - 1][j + 2] = 1;
			if (c(i - 1, j - 2)) g[i][j][i - 1][j - 2] = 1;
			if (c(i + 2, j + 1)) g[i][j][i + 2][j + 1] = 1;
			if (c(i + 2, j - 1)) g[i][j][i + 2][j - 1] = 1;
			if (c(i - 2, j + 1)) g[i][j][i - 2][j + 1] = 1;
			if (c(i - 2, j - 1)) g[i][j][i - 2][j - 1] = 1;
		}
	}
	for (int x3 = 0; x3 < 8; x3++) {
		for (int y3 = 0; y3 < 8; y3++) {
			for (int x1 = 0; x1 < 8; x1++) {
				for (int y1 = 0; y1 < 8; y1++) {
					for (int x2 = 0; x2 < 8; x2++) {
						for (int y2 = 0; y2 < 8; y2++) {
							if (g[x1][y1][x2][y2] > g[x1][y1][x3][y3] + g[x3][y3][x2][y2]) {
								g[x1][y1][x2][y2] = g[x1][y1][x3][y3] + g[x3][y3][x2][y2];
								opt[x1][y1][x2][y2] = { x3, y3 };
							}
						}
					}
				}
			}
		}
	}
}

void update_path(int x, int y, int fx, int fy) {
	if (opt[x][y][fx][fy] == pair <int, int>(-1, -1)) {
		path.push_back({ fx, fy });
	}
	else {
		update_path(x, y, opt[x][y][fx][fy].first, opt[x][y][fx][fy].second);
		update_path(opt[x][y][fx][fy].first, opt[x][y][fx][fy].second, fx, fy);

	}
}

void make_ans() {
	int l = 0;
	for (int i = 1; i < path.size(); i++) {
		if (p[path[i].first][path[i].second]) {
			for (int j = i; j > l; j--) {
				string s = "";
				s += char(path[j].first + 'a');
				s += char(path[j].second + '1');
				s += '-';
				s += char(path[j - 1].first + 'a');
				s+=char(path[j - 1].second + '1');
				ans.push_back(s);
			}
			l = i;
		}
	}
}

int main() {
	ios::sync_with_stdio(0);

	int k;
	cin >> k;
	for (int i = 0; i < k; i++) {
		string s;
		cin >> s;
		p[s[0] - 'a'][s[1] - '1'] = 1;
	}
	make_graph();
	for (int j = 0; j < 8; j++) {
		for (int i = 0; i + j * 8 < k && i < 8; i++) {
			if (p[i][j]) u[i][j] = true;
			for (int x = 0; x < 8; x++) {
				for (int y = 0; y < 8; y++) {
					if (u[i][j]) continue;
					if (!u[x][y] && p[x][y]) {
						path.clear();
						path.push_back({ i, j });
						update_path(i, j, x, y);
						make_ans();
						p[x][y] = 0;
						p[i][j] = 1;
						u[i][j] = 1;
					}
				}
			}
		}
	}

	cout << ans.size() << endl;
	for (auto i : ans)
		cout << i << '\n';
	return 0;

}