#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <ctime>
#include <cassert>
#include <random>
#include <functional>
#include <numeric>
#include <deque>
#include <queue>
#include <cstring>
#include <complex>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define x first
#define y second

using namespace std;

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

vector<pair<int, int> > dir = { {1, 2}, {2, 1}, {1, -2}, {-2, 1}, {-1, 2}, {2, -1}, {-1, -2}, {-2, -1} };

vector<pair<int, int> > bfs(int i1, int j1, int i2, int j2) {
	vector<vector<int> > dist(8, vector<int>(8, 1e9));
	vector<vector<pair<int, int> > > pr(8, vector<pair<int, int> >(8, { -1, -1 }));
	dist[i1][j1] = 0;
	vector<pair<int, int> > q;
	q.push_back({ i1, j1 });
	for (int z = 0; z < (int)q.size(); z++) {
		int x1 = q[z].first, y1 = q[z].second;
		for (auto elem : dir) {
			int x2 = x1 + elem.first, y2 = y1 + elem.second;
			if (x2 < 0 || x2 >= 8 || y2 < 0 || y2 >= 8) {
				continue;
			}
			if (dist[x2][y2] > dist[x1][y1] + 1) {
				dist[x2][y2] = dist[x1][y1] + 1;
				q.push_back({ x2, y2 });
				pr[x2][y2] = { x1, y1 };
			}
		}
	}
	vector<pair<int, int> > path;
	while (i2 != -1) {
		path.push_back({ i2, j2 });
		auto elem = pr[i2][j2];
		i2 = elem.first, j2 = elem.second;
	}
	reverse(path.begin(), path.end());
	return path;
}

int main()
{
	int n;
	cin >> n;
	vector<vector<bool> > used(8, vector<bool>(8));
	for (int i = 0; i < n; i++) {
		char c1, c2;
		cin >> c1 >> c2;
		used[c2 - '1'][c1 - 'a'] = 1;
	}
	vector<pair<pair<int, int>, pair<int, int> > > ans;
	while (1) {
		int x1 = -1, y1 = -1, x2 = -1, y2 = -1;
		for (int i = 0; i < 8; i++) {
			for (int j = 0; j < 8; j++) {
				if (!used[i][j] && x1 == -1) {
					x1 = i, y1 = j;
				}
				if (x1 != -1 && used[i][j]) {
					x2 = i, y2 = j;
					break;
				}
			}
			if (x2 != -1) break;
		}
		//cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
		if (x2 == -1) {
			break;
		}
		auto path = bfs(x1, y1, x2, y2);
		int last = 0;
		for (int i = 1; i < (int)path.size(); i++) {
			if (used[path[i].first][path[i].second]) {
				for (int j = i; j > last; j--) {
					ans.push_back({ path[j], path[j - 1] });
					used[path[j].first][path[j].second] = 0;
					used[path[j - 1].first][path[j - 1].second] = 1;
				}
				last = i;
			}
		}
	}
	assert(ans.size() <= 1500);
	cout << (int)ans.size() << endl;
	for (auto elem : ans) {
		cout << char(elem.first.second + 'a') << char(elem.first.first + '1') << '-';
		cout << char(elem.second.second + 'a') << char(elem.second.first + '1') << endl;
	}
	return 0;
}
