#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <string>
#include <ctime>
#include <cassert>
#include <random>
#include <functional>
#include <numeric>
#include <deque>
#include <queue>
#include <cstring>
#include <complex>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define x first
#define y second

using namespace std;

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int alf = 30;

vector<vector<int> > go;
vector<int> suf, len, dp, used;
vector<bool> term;

int new_vertex() {
	go.push_back(vector<int>(alf, -1));
	suf.push_back(-1);
	len.push_back(0);
	term.push_back(0);
	return (int)go.size() - 1;
}

void build(string s) {
	new_vertex();
	int root = 0, last = 0;
	for (char e : s) {
		int c = e - 'a';
		int new_last = new_vertex();
		len[new_last] = len[last] + 1;
		int p = last;
		last = new_last;
		while (p != -1 && go[p][c] == -1) {
			go[p][c] = last;
			p = suf[p];
		}
		if (p == -1) {
			suf[last] = root;
			continue;
		}
		int q = go[p][c];
		if (len[q] == len[p] + 1) {
			suf[last] = q;
			continue;
		}
		int r = new_vertex();
		go[r] = go[q];
		len[r] = len[p] + 1;
		suf[r] = suf[q];
		suf[q] = r;
		suf[last] = r;
		while (p != -1 && go[p][c] == q) {
			go[p][c] = r;
			p = suf[p];
		}
	}
	while (last != -1) {
		term[last] = 1;
		last = suf[last];
	}
}

void dfs(int u) {
	used[u] = 1;
	for (int c = 0; c < alf; c++) {
		if (go[u][c] == -1) continue;
		if (!used[go[u][c]]) dfs(go[u][c]);
		dp[u] += dp[go[u][c]];
	}
	dp[u] += term[u];
}

vector<int> prefix_func(string s) {
	vector<int> ans(s.size());
	for (int i = 1; i < (int)s.size(); i++) {
		int last = ans[i - 1];
		while (last > 0 && s[last] != s[i]) {
			last = ans[last - 1];
		}
		if (s[last] == s[i]) {
			ans[i] = last + 1;
		}
		else {
			ans[i] = last;
		}
	}
	return ans;
}

int main()
{
	string s, t;
	cin >> s >> t;
	build(s.substr(1));
	dp.resize(go.size());
	used.resize(go.size());
	int v = 0;
	vector<int> cnt(t.size());
	dfs(0);
	for (int i = 0; i < (int)t.size(); i++) {
		v = go[v][t[i] - 'a'];
		if (v == -1) break;
		cnt[i] = dp[v];
	}
	auto pr = prefix_func(t);
	/*for (int i = 0; i < (int)pr.size(); i++)
		cout << pr[i] << ' ';
	cout << endl;
	for (int i = 0; i < (int)cnt.size(); i++) {
		cout << cnt[i] << ' ';
	}
	cout << endl;*/
	long long ans = 0;
	for (int i = 0; i < (int)t.size(); i++) {
		if (pr[i] == 0) ans += (int)s.size();
		else ans += (int)s.size() - cnt[i - pr[i]];
	}
	cout << ans << endl;
	return 0;
}

