#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <fstream>
#include <iomanip>
#include <string>
using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define pb push_back 
#define x first
#define y second

const int INF = int(1e9) + 111;
const int N = int(1e5) + 11;
const int M = int(1e9) + 7;

vector<string> text, list;
map<string, string> mp;

bool cite(string s) {
	if (s.substr(0, 6) != "\\cite{")
		return false;
	for (int i = sz(s) - 1; i >= 6; i--) {
		if (s[i] == '}')
			return true;
	}
	return false;
}
bool bibitem(string s) {
	return (s.substr(0, 9) == "\\bibitem{" && s.back() == '}');
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("input.txt");
	//ofstream cout("output.txt");
	string s;
	while (cin >> s) {
		if (s == "\\begin{thebibliography}{99}")
			break;
		if (cite(s)) {
			s.erase(s.begin(), s.begin() + 6);
			while (s.back() != '}')
				s.pop_back();
			text.pb("\\bibitem{" + s);
		}
	}
	string tmp = "", bib;
	while (cin >> s) {
		if (s == "\\end{thebibliography}")break;
		if (bibitem(s)) {
			list.pb(s);
			bib = s;
			tmp = "";
		}
		else {
			tmp += " " + s;
			mp[bib] = tmp;
		}
	}
	if (text == list)
		cout << "Correct";
	else {
		cout << "Incorrect\n";
		cout << "\\begin{thebibliography}{99}\n";
		for (auto el : text) {
			cout << el << mp[el] << endl;
		}
		cout << "\\end{thebibliography}";
	}
	return 0;
}
