#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <fstream>
#include <iomanip>
#include <string>
#include <queue>
using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define pb push_back 
#define x first
#define y second

const int INF = int(1e9) + 111;
const int N = int(1e5) + 11;
const int M = int(1e9) + 7;

int used[10][10];
pair <int, int> p[10][10];
int n;
int isHorse[10][10];
vector <pair<int, int>> pos;
vector <pair<int, int>> per =
{
	{ 1,2 },
	{ 1, -2 },
	{ 2, 1 },
	{ 2, -1 },
	{ -1, 2 },
	{ -1, -2 },
	{ -2, 1 },
	{ -2, -1 }
};
bool correct(int i, int j, int i1, int j1) {
	return i >= 0 && j >= 0 && i < 8 && j < 8 && !used[i][j] && (j1 < j || j1 == j && i1 < i);
}
struct str {
	pair <int, int> end;
	pair <int, int> start;

};
vector <str> ans;
void bfs(int i, int j) {
	pair <int, int> st = { i, j };
	queue <pair<int, int>> q;
	q.push(st);
	used[st.x][st.y] = 1;
	while (!q.empty()) {
		pair <int, int> v = q.front();
		q.pop();
		//cout << v.x << " " << v.y << endl;
		for (auto el : per) {
			pair <int, int> to = { v.x + el.x, v.y + el.y };
			if (correct(to.x, to.y, i, j)) {
				//cout << to.x << " " << to.y << endl;
				p[to.x][to.y] = v;
				used[to.x][to.y] = 1;
				q.push(to);
				if (isHorse[to.x][to.y]) {
					//cout << 111;
					isHorse[to.x][to.y] = 0;
					while (to != st) {
						str tmp;
						tmp.end.y = to.y;
						tmp.end.x = to.x;
						tmp.start.x = p[to.x][to.y].x;
						tmp.start.y = p[to.x][to.y].y;
						ans.push_back(tmp);
						to = p[to.x][to.y];
					}
					isHorse[st.x][st.y] = 1;
					return;
				}
			}
		}
	}

}
void init() {
	for (int i = 0; i < 8; i++)
		for (int j = 0; j < 8; j++)
			used[i][j] = 0;

}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("input.txt");
	//ofstream cout("output.txt");
	cin >> n;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		isHorse[s[0] - 'a'][s[1] - '1'] = 1;
	}
	int t = 0;
	for (int j = 0; j < 8; j++) {
		for (int i = 0; i < 8; i++) {

			if (t == n)
				break;
			if (isHorse[i][j]) {
				t++;
				continue;
			}
			init();
			bfs(i, j);
			t++;
		}
	}
	cout << sz(ans) << endl;
	for (auto el : ans) {
		cout << char('a' + el.end.x) << el.end.y + 1 << "-" << char('a' + el.start.x) << el.start.y + 1 << endl;
	}
	return 0;
}