#include <bits/stdc++.h>
using namespace std;

#define fst first
#define snd second
#define mp make_pair
#define rep(i,a,n) for(int i=(a);i<(n);++i)
#define per(i,a,n) for(int i=(n)-1;i>=(a);--i)
#define all(x) (x).begin(),(x).end()

template<typename T1, typename T2>
inline bool umin(T1& x, const T2& y) {return x>y ? x=y,true:false;}

template<typename T1, typename T2>
inline bool umax(T1& x, const T2& y) {return x<y ? x=y,true:false;}

typedef long long ll;
typedef long double ld;

const int N    = (int)1e6+7;
const int mod  = (int)1e9+7;
const int INF  = (int)1e9+17;
const ll LLINF = (ll)1e18+17;

const int dx[8] = {-2, -2, -1, 1, 2, 2, 1, -1};
const int dy[8] = {-1, 1, -2, -2, 1, -1, 2, 2};

int board[8][8];
bool used[8][8];
pair<int, int> p[8][8];
vector<pair<pair<int, int>, pair<int, int> > > moves;

string f(pair<int, int> x) {
    string result = "--";
    result[0] = 'a' + x.second;
    result[1] = '1' + x.first;
    return result;
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
#endif

    int k;
    cin >> k;

    string s;
    for(int i = 0; i < k; ++i) {
        cin >> s;
        board[s[1] - '1'][s[0] - 'a'] = 1;
    }

    for(int i = 0; i < k; ++i) {
        int x = i / 8, y = i % 8;
        if(board[x][y] == 0) {
            int kx, ky;
            for(int j = 63; j >= 0; --j) {
                kx = j / 8;
                ky = j % 8;
                if(board[kx][ky] == 1) {
                    break;
                }
            }

            for(int a = 0; a < 8; ++a)
                for(int b = 0; b < 8; ++b)
                    used[a][b] = 0;

            queue<pair<int, int> > q;
            q.push({x, y});
            used[x][y] = true;

            bool found = false;
            while(!q.empty() && !found) {
                pair<int, int> cur = q.front();
                q.pop();

                for(int j = 0; j < 8; ++j) {
                    int nx = cur.first + dx[j];
                    int ny = cur.second + dy[j];
                    if(nx >= 0 && ny >= 0 && nx < 8 && ny < 8) {
                        if(!used[nx][ny]) {
                            used[nx][ny] = true;
                            p[nx][ny] = cur;
                            q.push({nx, ny});

                            if(nx == kx && ny == ky) {
                                found = true;
                                break;
                            }
                        }
                    }
                }
            }

            vector<pair<int, int> > task;

            for(pair<int, int> cur = {kx, ky}; cur != mp(x, y); cur = p[cur.first][cur.second]) {
                task.push_back(cur);
            }
            task.push_back({x, y});

            reverse(all(task));

            int prev = 0;
            for(int i = 0; i < task.size(); ++i) {
                if(board[task[i].first][task[i].second] == 1) {
                    for(int j = i - 1; j >= prev; --j) {
                        moves.push_back({task[j + 1], task[j]});
                        swap(board[task[j + 1].first][task[j + 1].second],
                             board[task[j].first][task[j].second]);
                    }
                    prev = i;
                }
            }
        }
    }

    cout << moves.size() << "\n";
    for(auto x : moves) {
        cout << f(x.first) << "-" << f(x.second) << "\n";
    }


    return 0;
}
