#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <cstdio>
#include <stdio.h>
#include <random>
#include <queue>

using namespace std;

int n, need_x, need_y, cnt;
set<pair<int, int> > k;
bool field[8][8], lock[8][8];
int dx[8] = { -2, -1, 1, 2, 2, 1, -1, -2 };
int dy[8] = { 1, 2, 2, 1, -1, -2, -2, -1 };

pair<int, int> get() {
	string s;
	cin >> s;
	return { s[0] - 'a', s[1] - '1' };
}

bool on_board(int x, int y) {
	return x >= 0 && x < 8 && y >= 0 && y < 8;
}

vector<pair<int, int> > get_path(int sx, int sy, int fx, int fy) {
	queue<pair<int, int> > q;
	q.push({ sx, sy });
	pair<int, int> prv[8][8];
	prv[sx][sy] = { -1, -1 };
	bool used[8][8];
	memset(used, 0, sizeof(used));

	while (!q.empty()) {
		pair<int, int> now = q.front();
		used[now.first][now.second] = 1;
		q.pop();

		for (int o = 0; o < 8; ++o) {
			int nx = now.first + dx[o];
			int ny = now.second + dy[o];
			if (!used[nx][ny] && on_board(nx, ny)) {
				prv[nx][ny] = now;
				q.push({ nx, ny });
			}
		}
	}

	vector<pair<int, int> > path;
	int ffx = fx, ffy = fy;
	while (ffx != -1) {
		path.push_back({ ffx, ffy });
		pair<int, int> p = prv[ffx][ffy];
		ffx = p.first;
		ffy = p.second;
	}

	reverse(path.begin(), path.end());

	k.erase({ sx, sy });
	k.insert({ fx, fy });

	return path;
}

bool bad(pair<int, int> p) {
	return field[p.first][p.second];
}

string turn(pair<int, int> a, pair<int, int> b) {
	string res = "";
	res += (a.first + 'a');
	res += ('1' + a.second);
	res += '-';
	res += (b.first + 'a');
	res += ('1' + b.second);
	field[a.first][a.second] = 0;
	field[b.first][b.second] = 1;
	return res;
}

vector<string> refine(vector<pair<int, int> > path) {
	vector<string> res;

	int last = path.size() - 1;
	int id = path.size() - 1;
	while (id > 0) {
		if (field[path[id].first][path[id].second]) {
			for (int i = id; i < last; ++i) {
				res.push_back(turn(path[i], path[i + 1]));
			}
			--last;
		}
		--id;
	}

	return res;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	for (int i = 0; i < n; ++i) {
		pair<int, int> pos = get();
		k.insert(pos);
		field[pos.first][pos.second] = 1;
	}

	vector<string> all;

	while (cnt != n) {
		pair<int, int> wow;
		for (pair<int, int> now : k) {
			if (!lock[now.first][now.second]) {
				wow = now;
				break;
			}
		}

		vector<pair<int, int> > path = get_path(wow.first, wow.second, need_x, need_y);
		vector<string> lol = refine(path);

		for (string s : lol) {
			all.push_back(s);
		}

		lock[need_x][need_y] = 1;
		++cnt;
		need_x += 1;
		if (need_x == 8) {
			need_x = 0;
			need_y += 1;
		}
	}

	cout << all.size() << endl;
	for (string s : all) {
		cout << s << endl;
	}

	return 0;
}
