#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
using ll = long long;
using ld = long double;

int n;
vector<string> s;

int find_next(int i, int j) {
    for (int r = j; r < s[i].size(); ++r) {
        if (s[i][r] == '}') return r;
    }
    return -1;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    s.push_back("");
    char ch;
    while ((ch = getchar()) != -1) {
        if (ch == '\n') {
            s.push_back("");
        } else {
            s.back().push_back(ch);
        }
    }

    n = s.size();

    string bib = "\\begin{thebibliography}";

    int bibpos = -1;
    for (int i = n - 1; i >= 0; --i) {
        if (s[i].size() >= bib.size() && s[i].substr(0, bib.size()) == bib) {
            bibpos = i;
            break;
        }
    }
    assert(bibpos != -1);

    vector<string> tok;
    map<string, int> id;

    string tk = "\\cite{";
    for (int i = 0; i < bibpos; ++i) {
        int k = 0;
        for (int j = 0; j < s[i].size(); ++j) {
            if (s[i][j] == tk[k]) k++;
            if (k == tk.size()) {
                int r = find_next(i, j + 1);
                assert(r != -1);

                string t = s[i].substr(j + 1, r - j - 1);
                id[t] = tok.size();
                tok.push_back(t);

                k = 0;
            }
        }
    }


    vector<string> val(tok.size());

    bool ok = true;
    for (int i = bibpos + 1, j = 0; i < n - 1; ++i, ++j) {
        if (s[i].substr(0, 4) == "\\end") break;
        string t = s[i].substr(9, find_next(i, 9) - 9);
        if (t != tok[j]) {
            ok = false;
        }

        val[id[t]] = s[i];
    }

    if (ok) {
        cout << "Correct" << endl;
    } else {
        cout << "Incorrect\n";
        cout << "\\begin{thebibliography}{99}\n";
        for (auto &it : val) {
            cout << it << "\n";
        }
        cout << "\\end{thebibliography}\n";
    }
}
