#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
using ll = long long;
using ld = long double;

map<pair<int, pair<int, int>>, ll> mem;

ll get(int ii, int jj, int kk) {
    int i = min(ii, min(jj, kk));
    int k = max(ii, max(jj, kk));
    int j = ii ^ jj ^ kk ^ i ^ k;

    if (mem.count({i, {j, k}})) {
        return mem[{i, {j, k}}];
    }

    cout << "? " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
    ll x;
    cin >> x;
    mem[{i, {j, k}}] = x;
    return x;
}

const int MAXN = 1e3 + 5;
int n;
ll a[MAXN];

bool check(int pos) {
    for (int i = pos; i < pos + 5; ++i) {
        if (a[i] < 0) return false;
    }

    for (int i = pos; i < pos + 5; ++i) {
        for (int j = i + 1; j < pos + 5; ++j) {
            for (int k = j + 1; k < pos + 5; ++k) {
                if (get(i, j, k) != min(a[i], min(a[j], a[k])) + max(a[i], max(a[j], a[k]))) return false;
            }
        }
    }
    return true;
}

void solve(int pos) {
    vector<int> p(5);
    for (int i = 0; i < 5; ++i) p[i] = i;

    do {
        ll x02 = get(pos + p[0], pos + p[1], pos + p[2]);
        ll x24 = get(pos + p[2], pos + p[3], pos + p[4]);
        ll x04 = get(pos + p[0], pos + p[2], pos + p[4]);

        ll a2 = x02 - x04 + x24;
        if (a2 % 2 != 0) continue;
        a2 /= 2;

        ll a0 = x02 - a2;
        ll a4 = x24 - a2;

        ll x14 = get(pos + p[1], pos + p[2], pos + p[4]);
        ll x03 = get(pos + p[0], pos + p[1], pos + p[3]);

        ll a1 = x14 - a4;
        ll a3 = x03 - a0;

        a[pos + p[0]] = a0;
        a[pos + p[1]] = a1;
        a[pos + p[2]] = a2;
        a[pos + p[3]] = a3;
        a[pos + p[4]] = a4;

        if (check(pos)) return;
    } while (next_permutation(p.begin(), p.end()));

    assert(false);
}

int main() {
    //freopen("input", "r", stdin);
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 0; i + 5 <= n; i += 5) {
        solve(i);
    }

    if (n % 5 != 0) {
        solve(n - 5);
    }

    cout << "! ";
    for (int i = 0; i < n; ++i) {
        cout << a[i] << ' ';
    }
    cout << endl;
}
