#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>

#define int long long

#define all(a) a.begin(), a.end()

using namespace std;

const int BASE1 = 1e+9 + 7, BASE2 = 1e+9 + 9;
const int P1 = 31, P2 = 101;
const int N = 1e+6 + 1;
int p1[N], p2[N];

signed main()
{
	//freopen("input.txt", "r", stdin);
	p1[0] = 1;
	p2[0] = 1;
	for (int i = 1; i < N; i++) {
		p1[i] = (p1[i - 1] * P1) % BASE1;
		p2[i] = (p2[i - 1] * P2) % BASE2;
	}

	int n;
	cin >> n;
	vector<string> a(n);

	map<pair<int, int>, vector<pair<int, int>>> m;

	for (int i = 0; i < n; i++) {
		cin >> a[i];
		string t;
		cin >> t;

		int curmask = 0;
		for (char x : t)
			curmask |= 1 << (x - 'a');

		int len = a[i].size() - 1;
		while (len >= 0 && (curmask & (1 << (a[i][len] - 'a'))))
			len--;

		len++;

		int h1 = 0, h2 = 0;
		for (int j = 0; j < len; j++) {
			h1 = (h1 + p1[j] * (a[i][j] - 'a' + 1)) % BASE1;
			h2 = (h2 + p2[j] * (a[i][j] - 'a' + 1)) % BASE2;
		}

		m[{ h1, h2 }].push_back({ curmask, i });
	}


	vector<vector<int>> ans;
	for (auto a : m) {
		vector<pair<int, int>> t = a.second;
		
		for (int i = 0; i < t.size(); ) {
			vector<int> cur;
			cur.push_back(t[i].second);
			int j = i + 1;
			while (j < t.size() && t[i].first == t[j].first) {
				cur.push_back(t[j].second);
				j++;
			}
			i = j;
			ans.push_back(cur);
		}
	}

	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i].size() << ' ';
		for (int x : ans[i])
			cout << x + 1 << ' ';
		cout << '\n';
	}
}
