#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MOD = (1ll << 32);
const ll INF = 6e18;

ll solve(const vector<int> &a) {
    int n = a.size();

    vector<ll> realmin(n), suffmin(n);
    vector<ll> realmax(n), suffmax(n);

    realmin[n - 1] = realmax[n - 1] = a[n - 1];
    suffmin[n - 1] = INF;
    suffmax[n - 1] = -INF;

    for (int i = n - 2; i >= 0; --i) {
        realmin[i] = min(1ll * a[i], realmin[i + 1]);
        if (realmin[i + 1] == a[i]) {
            suffmin[i] = suffmin[i + 1];
        } else {
            suffmin[i] = min(realmin[i + 1], 1ll * a[i]);
        }

        realmax[i] = max(1ll * a[i], realmax[i + 1]);
        if (realmax[i + 1] == a[i]) {
            suffmax[i] = suffmax[i + 1];
        } else {
            suffmax[i] = max(realmax[i + 1], 1ll * a[i]);
        }
    }

    // cout << suffmax[0] << '\n';

    ll ans = INF;

    for (int i = 0; i < n - 1; ++i) {
        if (suffmin[i + 1] == INF && suffmax[i + 1] == -INF) {
            continue;
        } else if (suffmin[i + 1] == INF) {
            ans = min(ans, 1ll * a[i] * suffmax[i + 1]);
        } else if (suffmax[i + 1] == -INF) {
            ans = min(ans, 1ll * a[i] * suffmin[i + 1]);
        } else {
            ans = min(ans, min(1ll * a[i] * suffmax[i + 1], 1ll * a[i] * suffmin[i + 1]));
        }
    }

    return ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int t;
	cin >> t;

	for (int test = 0; test < t; ++test) {
        int n, l, r, x, y, z;
        cin >> n >> l >> r >> x >> y >> z;

        vector<int> b(n);
        cin >> b[0] >> b[1];

        for (int i = 2; i < n; ++i) {
            b[i] = (1ll * b[i - 2] * x + 1ll * b[i - 1] * y + z) % MOD;
        }

        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            a[i] = b[i] % (r - l + 1) + l;
        }

        // for (auto i : a) {
        //     cout << ' ' << i;
        // }
        // cout << '\n';

        ll ans = solve(a);

        if (ans == INF) {
            cout << "IMPOSSIBLE\n";
        } else {
            cout << ans << '\n';
        }
	}

	return 0;
}
