#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<bool>> used;
vector<pair<pair<int, int>, pair<int, int>>> ans;
vector<vector<bool>> knights;
vector<vector<bool>> done;

bool good(int x, int y)
{
    return x >= 0 && x < 8 && y >= 0 && y < 8;
}

bool dfs(int x, int y)
{
    used[x][y] = true;

    if (knights[x][y])
    {
        knights[x][y] = false;
        return true;
    }

    if (good(x - 2, y - 1) && !done[x - 2][y - 1] && !used[x - 2][y - 1] && dfs(x - 2, y - 1))
    {
        ans.push_back({{x - 2, y - 1}, {x, y}});
        return true;
    }
    if (good(x + 2, y - 1) && !done[x + 2][y - 1] && !used[x + 2][y - 1] && dfs(x + 2, y - 1))
    {
        ans.push_back({{x + 2, y - 1}, {x, y}});
        return true;
    }
    if (good(x - 2, y + 1) && !done[x - 2][y + 1] && !used[x - 2][y + 1] && dfs(x - 2, y + 1))
    {
        ans.push_back({{x - 2, y + 1}, {x, y}});
        return true;
    }
    if (good(x + 2, y + 1) && !done[x + 2][y + 1] && !used[x + 2][y + 1] && dfs(x + 2, y + 1))
    {
        ans.push_back({{x + 2, y + 1}, {x, y}});
        return true;
    }

    if (good(x - 1, y - 2) && !done[x - 1][y - 2] && !used[x - 1][y - 2] && dfs(x - 1, y - 2))
    {
        ans.push_back({{x - 1, y - 2}, {x, y}});
        return true;
    }
    if (good(x + 1, y - 2) && !done[x + 1][y - 2] && !used[x + 1][y - 2] && dfs(x + 1, y - 2))
    {
        ans.push_back({{x + 1, y - 2}, {x, y}});
        return true;
    }
    if (good(x - 1, y + 2) && !done[x - 1][y + 2] && !used[x - 1][y + 2] && dfs(x - 1, y + 2))
    {
        ans.push_back({{x - 1, y + 2}, {x, y}});
        return true;
    }
    if (good(x + 1, y + 2) && !done[x + 1][y + 2] && !used[x + 1][y + 2] && dfs(x + 1, y + 2))
    {
        ans.push_back({{x + 1, y + 2}, {x, y}});
        return true;
    }

    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    knights.resize(8, vector<bool>(8, false));
    done.resize(8, vector<bool>(8, false));

    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        char c;
        cin >> c;
        int x;
        cin >> x;

        knights[x - 1][c - 'a'] = true;
    }

    bool flag = false;
    if (n > 32) {
        n = 64 - n;
        flag = true;

        reverse(knights.begin(), knights.end());
        for (auto &v : knights)
            reverse(v.begin(), v.end());

        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                if (knights[i][j])
                    knights[i][j] = false;
                else
                    knights[i][j] = true;
            }
        }
    }

    used.resize(8, vector<bool>(8, false));
    for (int i = 0; i < n / 8; i++) {
        for (int j = 0; j < 8; j++) {
            if (knights[i][j]) {
                done[i][j] = true;
                continue;
            }

            used.assign(8, vector<bool>(8, false));
            dfs(i, j);
            done[i][j] = true;
            knights[i][j] = true;
        }
    }

    int i = n / 8;
    for (int j = 0; j < n % 8; j++)
    {
        if (knights[i][j]) {
            done[i][j] = true;
            continue;
        }

        used.assign(8, vector<bool>(8, false));
        dfs(i, j);
        done[i][j] = true;
        knights[i][j] = true;
    }

    if (flag)
    {
        reverse(ans.begin(), ans.end());
        for (auto p : ans)
            swap(p.first, p.second);
    }

    cout << ans.size() << endl;
    for (auto p : ans)
    {
        cout << (char)('a' + p.first.second) << 1 + p.first.first << "-"
             << (char)('a' + p.second.second) << 1 + p.second.first << endl;
    }

    return 0;
}