#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double

const int INF = 3e9;
const int BINF = 5e18;

struct Node {
    int x, y, m;
    Node *L, *R;

    Node(int x) : x(x), y(rand()), m(x), L(nullptr), R(nullptr) {};
};

int m(Node *t) {
    return t == nullptr ? -INF : t->m;
}

void update(Node *t) {
    if (t == nullptr) return;
    t->m = max(m(t->L), m(t->R));
}

Node *merge(Node *a, Node *b) {
    if (a == nullptr) return b;
    if (b == nullptr) return a;
    if (a->y < b->y) {
        a->R = merge(a->R, b);
        update(a);
        return a;
    } else {
        b->L = merge(a, b->L);
        update(b);
        return b;
    }
}

pair<Node *, Node *> split(Node *t, int x) {
    if (t == nullptr) return {nullptr, nullptr};
    if (t->x < x) {
        auto r = split(t->R, x);
        t->R = r.first;
        update(t);
        return {t, r.second};
    } else {
        auto l = split(t->L, x);
        t->L = l.second;
        update(t);
        return {l.first, t};
    }
}

Node *add(Node *t, int x) {
    auto tmp = split(t, x);
    return merge(merge(tmp.first, new Node(x)), tmp.second);
}

int32_t main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);

    int t, n, l, r, x, y, z, b1, b2;
    cin >> t;
    for (int k = 0; k < t; k++) {
        cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
        int ai, bi;
        int M2 = ((int) 1) << 32;
        int MINI = BINF;
        int MIN = BINF;
        bool updated = false;
        Node *t = nullptr;
        for (int i = 0; i < n; i++) {
            if (i == 0) {
                bi = b1;
            } else if (i == 1) {
                bi = b2;
            } else {
                bi = (b1 * x + b2 * y + z) % M2;
            }
            ai = (bi % (r - l + 1)) + l;
            auto tmp = split(t, ai);
            int MAXI = m(tmp.first);
            if (MAXI != -INF && MAXI < ai && ai * MAXI < MIN) {
                MIN = MAXI * ai;
                updated = true;
            }
            t = merge(tmp.first, tmp.second);
            if (MINI != BINF && MINI < ai && MINI * ai < MIN) {
                MIN = MINI * ai;
                updated = true;
            }
            MINI = min(MINI, ai);
            if (i > 1) {
                b1 = b2;
                b2 = bi;
            }
            t = add(t, ai);
        }
        if (updated) {
            cout << MIN << '\n';
        } else {
            cout << "IMPOSSIBLE" << '\n';
        };
    }
    return 0;
}