#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;
#define fs first
#define sc second
const int inf = 2e9;
const ll linf = 1e18;
const int maxn = 10000100;


//#define LOCAL

#ifndef LOCAL
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#endif

char u[8][8];
int d[8][8];
pi p[8][8];
pi dx[8] = { { 2,1 },{ -2,1 },{ 2,-1 },{ -2,-1 },{ 1,2 },{ -1,2 },{ 1,-2 },{ -1,-2 } };


vector<string> bfs(int x, int y, bool f) {
	for (int i = 0; i < 8; ++i)
		for (int j = 0; j < 8; ++j) d[i][j] = inf;
	queue<pi> q;
	q.push({ y,x });
	d[y][x] = 0;
	while (!q.empty()) {
		pi v = q.front();
		q.pop();
		for (pi i : dx) {
			pi to = { v.fs + i.fs, v.sc + i.sc };
			if (to.fs >= 0 && to.fs < 8 && to.sc >= 0 && to.sc < 8) {
				if (u[to.fs][to.sc] == 2) {
					vector<string> s;
					u[to.fs][to.sc] = 0;
					p[to.fs][to.sc] = v;
					for (pi l = to; l != make_pair(y, x); l = p[l.fs][l.sc]) {
						string test;
						test += l.sc + 'a';
						test += l.fs + '1';
						test += '-';
						test += p[l.fs][l.sc].sc + 'a';
						test += p[l.fs][l.sc].fs + '1';
						s.push_back(test);
					}
					vector<string> ans;
					for (int j = s.size() - 1; j >= 0; --j) {
						if (u[s[j][3] - 'a'][s[j][4] - '1'] != 0) {
							ans.push_back(s[j]);
							s.erase(s.begin() + j);
						}
					}
					for (int j = 0; j < s.size(); ++j) ans.push_back(s[j]);
					u[y][x] = 1;
					return ans;
				}
				else {
					if (d[to.fs][to.sc] > d[v.fs][v.sc] + 1) {
						d[to.fs][to.sc] = d[v.fs][v.sc] + 1;
						p[to.fs][to.sc] = v;
						q.push(to);
					}
				}
			}
		}

	}
	return {};
}

int main() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		int x = s[0] - 'a';
		int y = s[1] - '1';
		u[y][x] = 2;
	}
	vector < string> ans;
	while (1) {
		bool flg = 1;
		for (int i = 0; i < n; ++i) {
			int x = i % 8;
			int y = i / 8;
			if (u[y][x] == 0) flg = 0;
			else {
				u[y][x] = 1;
				continue;
			}
			vector<string> s = bfs(x, y, 0);
			for (auto j : s) ans.push_back(j);
		}
		if (flg) break;
	}
	cout << ans.size() << endl;
	for (auto j : ans) cout << j << endl;
	return 0;
}