#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <ctime>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;
#define fs first
#define sc second
const int inf = 2e9;
const ll linf = 4e18 + 10;
const int maxn = 1e7 + 100;


//#define LOCAL

#ifndef LOCAL
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#endif

unsigned int b[maxn];
int a[maxn];

ll getmin(int n) {
	ll ans = linf;
	multiset<int> s;
	for (int i = 0; i < n; ++i) s.insert(a[i]);
	for (int i = 0; i < n - 1; ++i) {
		s.erase(s.find(a[i]));
		auto it = s.upper_bound(a[i]);
		auto end = s.end();
		if (it != end && a[i] < (*it)) ans = min(ans, 1ll * (*it)*a[i]);
		--end;
		if (a[i] < (*end)) ans = min(ans, 1ll * (*end)*a[i]);
	}
	return ans;
}


int main() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	for (int it = 0; it < t; ++it) {
		int n;
		int l, r;
		unsigned int x, y, z, b1, b2;
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		b[0] = b1;
		b[1] = b2;
		for (int i = 2; i < n; ++i) b[i] = (b[i - 2] * x + b[i - 1] * y + z);
		for (int i = 0; i < n; ++i) a[i] = ((ll)b[i]) % (r - l + 1) + l;
		/*int n;
		cin >> n;
		for (int i = 0; i < n; ++i) cin >> a[i];
		*/
		ll ans = getmin(n);
		if (ans == linf) cout << "IMPOSSIBLE" << endl;
		else cout << ans << endl;
	}
	return 0;
}

ll getmin2(int n) {
	ll ans = linf;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (a[i] < a[j]) ans = min(ans, 1ll * a[i] * a[j]);
		}
	}
	return ans;
}

int nemain() {
	mt19937 rng(time(NULL));
	int n = 5;
	int m = 1e1;
	for (int it = 0; it < 10000; ++it) {
		for (int i = 0; i < n; ++i) a[i] = rng() % (2 * m) - m;
		if (getmin(n) != getmin2(n)) {
			cout << "TEST" << endl;
			cout << n << endl;
			for (int i = 0; i < n; ++i) cout << a[i] << " ";
			cout << endl << getmin(n) << " != " << getmin2(n) << endl;
			system("PAUSE");
			return 0;
		}
	}
	cout << "all tests passed" << endl;
	system("PAUSE");
	return 0;
}