#include <iostream>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cmath>
#include <bitset>


using namespace std;

/*#pragma optimize("no-stack-protector")
#pragma optimize("Ofast")
#pragma optimize("unroll-loops")
#pragma optimize("fast-math")
#pragma target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")*/

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18 + 7;
const int inf = 1e9 + 7;
const ld eps = 1e-9;

struct Data
{
	ull a;
	ull h;
	int turn;

	Data() : turn(-1) {}
	Data(int a, int h) : a(a), h(h), turn(-1) {}
};

int main()
{
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	ios_base::sync_with_stdio(false);

	vector<string> keys;
	map<string, int> ord;
	vector<string> source;

	string s;
	while (cin >> s)
	{
		if (s == "\\begin{thebibliography}{99}")
			break;

		if (s.size() > 7)
		{
			string t;
			for (int i = 0; i < 6; i++)
			{
				t += s[i];
			}

			if (t == "\\cite{")
			{
				int ind = 6;
				string key;
				while (s[ind] != '}')
				{
					key += s[ind];
					ind++;
				}
				keys.push_back(key);
			}
		}
	}

	while (1)
	{
		getline(cin, s);
		if (s != "")
			break;
	}


	while (1)
	{
		if (s.size() > 4)
		{
			string t;
			for (int i = 0; i < 4; i++)
			{
				t += s[i];
			}
			if (t == "\\end")
				break;
		}

		int ind = 9;
		string key;
		while (s[ind] != '}')
		{
			key += s[ind];
			ind++;
		}
		ord[key] = source.size();
		source.push_back(s);

		getline(cin, s);
	}

	bool ok = true;
	for (int i = 0; i < keys.size(); i++)
	{
		if (ord[keys[i]] != i)
		{
			ok = false;
			break;
		}
	}

	if (ok)
	{
		cout << "Correct" << endl;
	}
	else
	{
		cout << "Incorrect" << endl;
		cout << "\\begin{thebibliography}{99}" << endl;
		for (int i = 0; i < keys.size(); i++)
		{
			cout << source[ord[keys[i]]] << endl;
		}
		cout << "\\end{thebibliography}" << endl;
	}

	return 0;
}