#include <iostream>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cmath>
#include <bitset>


using namespace std;

/*#pragma optimize("no-stack-protector")
#pragma optimize("Ofast")
#pragma optimize("unroll-loops")
#pragma optimize("fast-math")
#pragma target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")*/

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 5 * 1e18 + 7;
const int inf = 1e9 + 7;
const ld eps = 1e-9;

struct Data
{
	ull a;
	ull h;
	int turn;

	Data() : turn(-1) {}
	Data(int a, int h) : a(a), h(h), turn(-1) {}
};

int main()
{
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	ios_base::sync_with_stdio(false);

	int n, m, x, y;
	cin >> n >> m;

	vector<int> ind(n, 0);
	vector<set<int>> pr(n);

	for (int i = 0; i < m; i++) {
		cin >> x >> y;
		x--;
		y--;
		pr[x].insert(y);
		pr[y].insert(x);
	}

	int a = -1, b = -1;
	for (int i = 0; i < n; i++) {
		if (pr[i].size() < n - 1 && a == -1) {
			a = i;
			for (int j = 0; j < n; j++)
				if (i != j && pr[i].find(j) == pr[i].end()) {
					b = j;
					break;
				}
			break;
		}
	}


	if (a == -1 || b == -1) {
		cout << "NO" << endl;
		return 0;
	}
	cout << "YES" << endl;

	vector<int> ans(n, -1);
	ans[a] = n;
	ans[b] = n - 1;

	int cnt = 1;
	for (int i = 0; i < n; i++) {
		if (ans[i] == -1) {
			cout << cnt << ' ';
			cnt++;
		}
		else cout << ans[i] <<  ' ';
	}
	cout << endl;

	cnt = 1;
	for (int i = 0; i < n; i++) {
		if (ans[i] == -1) {
			cout << cnt << ' ';
			cnt++;
		}
		else cout << n << ' ';
	}

	cout << endl;
	return 0;
}