#include <iostream>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cmath>
#include <bitset>


using namespace std;

/*#pragma optimize("no-stack-protector")
#pragma optimize("Ofast")
#pragma optimize("unroll-loops")
#pragma optimize("fast-math")
#pragma target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")*/

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 1e18 + 7;
const int inf = 1e9 + 7;
const ld eps = 1e-9;

struct Data
{
	ull a;
	ull h;
	int turn;

	Data() : turn(-1) {}
	Data(int a, int h) : a(a), h(h), turn(-1) {}
};

int main()
{
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	ios_base::sync_with_stdio(false);

	int n;
	cin >> n;

	vector<Data> pl;

	for (int i = 0; i < n; i++)
	{
		int comm;
		cin >> comm;

		if (comm == 1)
		{
			pl.push_back({ 1, 1 });
		}
		else if (comm == 2)
		{
			int ind;
			cin >> ind;

			if (pl[ind - 1].turn == -1)
				pl[ind - 1].a *= 2;
		}
		else if (comm == 3)
		{
			int ind;
			cin >> ind;

			if (pl[ind - 1].turn == -1)
				pl[ind - 1].h *= 2;
		}
		else if (comm == 4)
		{
			int ind;
			cin >> ind;

			pl.push_back(pl[ind - 1]);
			if (pl.back().turn != -1)
				pl.back().turn = i + 1;
		}
		else
		{
			int x, y;
			cin >> x >> y;
			x--; y--;

			if (pl[x].turn == -1 && pl[y].turn == -1)
			{
				if (pl[x].h > pl[y].a)
					pl[x].h -= pl[y].a;
				else
					pl[x].turn = i + 1;

				if (pl[y].h > pl[x].a)
					pl[y].h -= pl[x].a;
				else
					pl[y].turn = i + 1;
			}
		}
	}

	cout << pl.size() << endl;
	for (Data d : pl)
	{
		cout << d.turn << ' ';
	}
	cout << endl;

	return 0;
}