#include <iostream>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cmath>
#include <bitset>


using namespace std;

/*#pragma optimize("no-stack-protector")
#pragma optimize("Ofast")
#pragma optimize("unroll-loops")
#pragma optimize("fast-math")
#pragma target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")*/

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 5 * 1e18 + 7;
const int inf = 1e9 + 7;
const ld eps = 1e-9;

struct Data
{
	ull a;
	ull h;
	int turn;

	Data() : turn(-1) {}
	Data(int a, int h) : a(a), h(h), turn(-1) {}
};

int main()
{
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	ios_base::sync_with_stdio(false);


	int t;
	ll n, l, r, x, y, z, b1, b2, bi;
	cin >> t;

	for (int i = 0; i < t; i++) {
		cin >> n >> l >> r >> x >> y >> z >> b1 >> b2;
		vector<ll> a(n);
		vector<ll> mn_suf(n, INF), mx_suf(n, -INF), mn_pref(n, INF), mx_pref(n, -INF);
		a[0] = b1 % (r - l + 1) + l;
		a[1] = b2 % (r - l + 1) + l;
		for (int j = 2; j < n; j++) {
			bi = ((1LL << 32) + b1 * x + b2 * y + z) % (1LL << 32);
			swap(b1, b2);
			b2 = bi;
			a[j] = (bi + r - l + 1) % (r - l + 1) + l;
		}

		mx_suf[n - 1] = a[n - 1];
		mn_suf[n - 1] = a[n - 1];
		for (int j = n - 2; j >= 0; j--) {
			mx_suf[j] = max(mx_suf[j + 1], a[j]);
			mn_suf[j] = min(mn_suf[j + 1], a[j]);
		}

		mx_pref[0] = a[0];
		mn_pref[0] = a[0];
		for (int j = 1; j < n; j++) {
			mx_pref[j] = max(mx_pref[j - 1], a[j]);
			mn_pref[j] = min(mn_pref[j - 1], a[j]);
		}

		ll ans = INF;
		for (int j = 0; j < n - 1; j++) {
			if (mx_suf[j + 1] != -INF && mx_suf[j + 1] > a[j])
				ans = min(ans, a[j] * mx_suf[j + 1]);
			if (mn_suf[j + 1] != INF && mn_suf[j + 1] > a[j])
				ans = min(ans, a[j] * mn_suf[j + 1]);
		}

		for (int j = 1; j < n; j++) {
			if (mx_pref[j - 1] != -INF && mx_pref[j - 1] < a[j])
				ans = min(ans, a[j] * mx_pref[j - 1]);
			if (mn_pref[j - 1] != INF && mn_pref[j - 1] < a[j])
				ans = min(ans, a[j] * mn_pref[j - 1]);
		}

		if (ans == INF) {
			cout << "IMPOSSIBLE" << endl;
			continue;
		}
		cout << ans << endl;

	}


	return 0;
}