#include <iostream>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cmath>
#include <bitset>


using namespace std;

/*#pragma optimize("no-stack-protector")
#pragma optimize("Ofast")
#pragma optimize("unroll-loops")
#pragma optimize("fast-math")
#pragma target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")*/

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF = 5 * 1e18 + 7;
const int inf = 1e9 + 7;
const ld eps = 1e-9;

struct Data
{
	int mask;
	ll hash1;
	ll hash2;
	int i;
};

const ll base1 = 271;
const ll mod1 = 1e9 + 7;
const ll base2 = 243;
const ll mod2 = 1e9 + 13;

ll gethash(string& s, const ll base, const ll mod)
{
	ll hash = 0;
	for (int i = 0; i < s.size(); i++)
	{
		hash = (hash * base + s[i]) % mod;
	}
	return hash;
}

int main()
{
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	ios_base::sync_with_stdio(false);

	
	int n;
	cin >> n;

	vector<pair<string, string>> inp(n);

	for (int i = 0; i < n; i++)
	{
		cin >> inp[i].first >> inp[i].second;
	}

	map<int, map<ll, vector<int>>> group;

	for (int i = 0; i < n; i++)
	{
		int mask = 0;
		for (char ch : inp[i].second)
		{
			mask |= 1 << (ch - 'a');
		}

		int sz = inp[i].first.size();
		for (int j = sz - 1; j >= 0; j--)
		{
			int ind = inp[i].first[j] - 'a';
			if (mask & (1 << ind))
			{
				inp[i].first.pop_back();
			}
			else
			{
				break;
			}
		}

		ll hash1 = gethash(inp[i].first, base1, mod1);

		group[mask][hash1].push_back(i + 1);
	}

	vector<vector<int>> ans;
	for (auto it1 = group.begin(); it1 != group.end(); it1++)
	{
		for (auto it2 = it1->second.begin(); it2 != it1->second.end(); it2++)
		{
			ans.push_back(it2->second);
		}
	}

	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++)
	{
		cout << ans[i].size() << ' ';
		for (int j = 0; j < ans[i].size(); j++)
		{
			cout << ans[i][j] << ' ';
		}
		cout << endl;
	}

	return 0;
}