import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Locale;
import java.util.Map;
import java.util.*;

public class Main {

    public void solve() throws IOException {
        int t = nextInt();
        BigInteger[] b = new BigInteger[(int) 2e4];
        BigInteger[] a = new BigInteger[(int) 2e4];

        for (int T = 0; T < t; T++) {
            int n = nextInt();
            if(n > 2e4) return;
            BigInteger l = new BigInteger(nextInt() + "");
            BigInteger r = new BigInteger(nextInt() + "");

            BigInteger x = new BigInteger(nextInt() + "");
            BigInteger y = new BigInteger(nextInt() + "");
            BigInteger z = new BigInteger(nextInt() + "");

            int b1 = nextInt();
            int b2 = nextInt();

            b[0] = new BigInteger(b1 + "");
            b[1] = new BigInteger(b2 + "");

            BigInteger mod1 = new BigInteger("4294967296");
            BigInteger mod2 = r.subtract(l).add(BigInteger.ONE);

            for (int i = 2; i < n; i++) {
                b[i] = b[i - 2].multiply(x).add(b[i - 1].multiply(y)).add(z).mod(mod1);
            }
            for (int i = 0; i < n; i++) {
                a[i] = b[i].mod(mod2).add(l);
            }
            BigInteger ans = mod1.multiply(mod1).multiply(mod1);
            for (int i = 0; i < n; i++) {
                for (int j = i + 1; j < n; j++) {
                    if (a[i].compareTo(a[j]) < 0) {
                        ans = ans.min(a[i].multiply(a[j]));
                    }
                }
            }
            if (ans.equals(mod1.multiply(mod1).multiply(mod1))) {
                System.out.println("IMPOSSIBLE");
            } else {
                System.out.println(ans);
            }
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

}
