#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>
#include<set>
#include<queue>
#include<string>

using namespace std;

typedef long long ll;

vector<vector<ll>>v(8, vector<ll>(8, 0));

ll INF = 1e9;

ll arr[8][2] = { {1,2}, {2,1}, {-1,2},{2,-1},{ -1,-2 },{ -2,-1 },{ 1,-2 },{ -2,1 } };

vector<string>ans;


ll bfs(ll mi, ll mj) {
	vector<vector<pair<ll, ll>>>p(8, vector<pair<ll, ll>>(8, { -1,-1 }));
	vector<vector<ll>>dist(8, vector<ll>(8, INF));
	queue<pair<ll, ll>>q;
	
	q.push({mi, mj});
	dist[mi][mj] = 0;
	ll sti = -1, stj = -1;

	while (!q.empty()) {
		ll curi = q.front().first;
		ll curj = q.front().second;
		q.pop();

		if (v[curi][curj] == 1) {
			sti = curi;
			stj = curj;
			break;
		}

		for (auto d : arr) {
			ll ni = curi + d[0];
			ll nj = curj + d[1];
			if (ni < 0 || nj < 0 || ni >= 8 || nj >= 8) {
				continue;
			}
			if (nj < mj) continue;
			if (nj == mj && ni < mi) continue;

			if (dist[ni][nj] == INF) {
				dist[ni][nj] = dist[curi][curj] + 1;
				p[ni][nj] = { curi, curj };
				q.push({ ni, nj });
			}
		}
	}

	if (sti == -1) {
		return 0;
	}

	for (ll i = sti, j = stj; p[i][j] != make_pair(ll(-1), ll(-1)); ) {
		ll ni, nj;
		ni = p[i][j].first;
		nj = p[i][j].second;

		string s;
		s.push_back(i + 'a');
		s.push_back(j + '1');
		s.push_back('-');
		s.push_back(ni + 'a');
		s.push_back(nj + '1');
		ans.push_back(s);

		swap(v[i][j], v[ni][nj]);

		i = ni;
		j = nj;
	}

	return 1;
}



signed main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	ll k;
	cin >> k;
	for (ll i = 0; i < k; i++) {
		char cx;
		ll x,y;
		cin >> cx >> y;
		x = cx - 'a';
		v[x][y-1] = 1;
	}


	for (ll j = 0; j < 8; j++) {
		for (ll i = 0; i < 8; i++) {
			if (bfs(i, j) == 0) {
				break;
			}
		}
	}

	cout << ans.size() << '\n';
	for (auto now : ans) {
		cout << now << '\n';
	}



	return 0;
}






