#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <sstream>

#define ll long long
#define ep emplace_back
using namespace std;

bool bibbegin(string &s) {
	return (s.size() > 2 && s[0] == '\\' && s[1] == 'b');
}

bool bibend(string &s) {
	return (s.size() > 2 && s[0] == '\\' && s[1] == 'e');
}

void split(string &s, vector<string> &a) {
	string tmp = "";
	a.clear();
	int i;
	for (i = 0; i < s.size(); i++) {
		if (s[i] == ' ')
			a.ep(tmp), tmp = "";
		else
			tmp += s[i];
	}
	a.ep(tmp);
}

map<string, int> cites;
map<int, string> name;
int cnt_cit = 0;

bool cite(string &s) {
	return (s.size() > 2 && s[0] == '\\' && s[1] == 'c');
}

void add(vector<string> &a) {
	string tmp;
	for (auto &j : a)
		if (cite(j)) {
			tmp = j;
			while (!(tmp.back() == '}'))
				tmp.pop_back();
			cites[tmp] = cnt_cit++;
		}
}

vector<vector<string> > ans;

string swp(string &s) {
	string tmp = "\\";
	tmp += "cite";
	tmp += s.substr(8, s.size() - 8);
	return tmp;
}

string norm(string s) {
	while (s.back() != '}')
		s.pop_back();
	return s;
}

int main() {
	//ios::sync_with_stdio(0), cin.tie(0);

	string line;
	getline(cin, line);
	vector<string> a;
	while (!bibbegin(line)) {
		split(line, a);
		add(a);
		//cout << ">>>>>>>>>" + line << endl;
		getline(cin, line);
	}

	for (auto &j : cites)
		name[j.second] = j.first;

	int i = 0;
	bool cor = true;
	getline(cin, line);
	ans.resize(cnt_cit);
	vector<string> A;
	string tmp;
	while (!bibend(line)) {
		split(line, A);
		getline(cin, line);
		while (!bibbegin(line) && !bibend(line)) {
			A.ep("\n");
			split(line, a);
			for (auto &it : a)
				A.ep(it);
			getline(cin, line);
		}
		tmp = norm(A[0]);
		//cout << ">>>>>>>>" << a[0] << ' ' << swp(a[0]) << endl;
		if (swp(tmp) != name[i]) {
			cor = false;
			ans[cites[swp(tmp)]] = A;
			//cout << ">>>>>>>>>>" << cites[swp(a[0])] << endl;
		}
		else {
			ans[i] = A;
		}	
		i++;
	}

	if (cor)
		cout << "Correct";
	else {
		cout << "Incorrect\n\\begin{thebibliography}{99}\n";
		for (auto &j : name){
			for (i = 0; i < ans[j.first].size(); i++) {
				cout << ans[j.first][i];
				if (i + 1 != ans[j.first].size() && ans[j.first][i] != "\n")
					cout << ' ';
			}
			cout << '\n';
		}
		cout << "\\end{thebibliography}";
	}
}