#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define popb pop_back
#define pf push_front
#define popf pop_front
#define sz(a) (ll)((a).size())
#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define die(cond) if(cond) for() {}
#define maxeq(a, b) if (a < b) a = b;
#define mineq(a, b) if (a > b) a = b;
#define heap priority_queue
#define hash_map unordered_map
#define hash_set unordered_set
#define endl "\n"
#define ft first
#define sd second
#define y1 y_1
using namespace std;
typedef long long ll;
typedef long double ld;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef set<ll> sll;
typedef map<ll, ll> mll;
const ll inf = numeric_limits<ll>::max()/2;
const ld pi = acos(-1);
const ld eps = 1e-6;

inline void read(), solve();

int main() {
    fast;
    read();
    solve();
    return 0;
}

struct graph {
    ll n;
    vector<vll> adj;
    graph() {}
    graph(ll n_) {
        n = n_;
        adj.resize(n);
    }
    void add(ll v, ll u) {
        adj[v].pb(u);
        adj[u].pb(v);
    }
};

graph g;
vector<pll> dirs = {{+1, +2},{+1,-2},{+2,+1},{+2,-1},{-2,+1},{-2,-1},{-1,+2},{-1,-2}};

ll tonum(ll x, ll y) {
    if (0 <= x && x < 8 && 0 <= y && y < 8) {
        return 8*x + y;
    }
    return -1;
}

void build() {
    g = graph(8*8);
    for (ll x0 = 0; x0 < 8; x0++) {
        for (ll y0 = 0; y0 < 8; y0++) {
            ll v = tonum(x0, y0);
            for (pll p : dirs) {
                ll x1 = x0+p.ft, y1 = y0+p.sd;
                ll u = tonum(x1, y1);
                if (u != -1) {
                    g.add(v, u);
                }
            }
        }
    }
}

ll k;
vll par, used;
vll path;
ll f[64];
vector<string> ans;

void bfs(ll s) {
    queue<ll> q;
    par.assign(64, -1);
    used.assign(64, 0);
    par[s] = -1;
    used[s] = 1;
    q.push(s);
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        for (ll u : g.adj[v]) {
            if (used[u]) {
                continue;
            }
            par[u] = v;
            used[u] = 1;
            q.push(u);
        }
    }
}

void getpath(ll v, ll u) {
    vll p1;
    while (par[v] != -1) {
        p1.pb(v);
        v = par[v];
    }
    vll p2;
    while (par[u] != -1) {
        p2.pb(u);
        u = par[u];
    }
    reverse(all(p2));
    path.clear();
    for (ll w : p1) {
        path.pb(w);
    }
    path.pb(v);
    for (ll w : p2) {
        path.pb(w);
    }
    reverse(all(path));
}

string get(ll v, ll u) {
    ll x0 = v / 8, y0 = v % 8;
    ll x1 = u / 8, y1 = u % 8;
    char c1 = 'a'+y0;
    char c2 = '1'+x0;
    char c3 = 'a'+y1;
    char c4 = '1'+x1;
    string ans = {c1, c2, '-', c3, c4};
    return ans;
}

void rec(ll i) {
    if (i + 1 >= sz(path)) {
        return;
    }
    if (f[path[i + 1]]) {
        rec(i + 1);
        if (!f[path[i+1]) {
            f[path[i]] = 0;
            f[path[i+1]] = 1;
            ans.pb(get(path[i], path[i+1]));
        } else {
            exit(1);
        }
    } else {
        f[path[i]] = 0;
        f[path[i+1]] = 1;
        ans.pb(get(path[i], path[i+1]));
        rec(i+1);
    }
}

inline void solve() {
    build();
    ll s = tonum(3, 3);
    bfs(s);
    ll cnt = 0;
    end2:;
    for (ll i = 0; i < 8; i++) {
        for (ll j = 0; j < 8; j++) {
            if (f[tonum(i, j)]) {
                continue;
            }
            for (ll k = 7; k >= 0; k--) {
                for (ll l = 7; l >= 0; l--) {
                    if (!f[tonum(k, l)]) {
                        continue;
                    }
                    if (i >= k && j >= l) {
                        goto end_of_loop;
                    }
                    ll v = tonum(i, j);
                    ll u = tonum(k, l);
                    getpath(v, u);
                    rec(0);
                    goto end2;
                }
            }
        }
    }
    end_of_loop:;
    cout << sz(ans) << endl;
    for (string& s : ans) {
        cout << s << endl;
    }
}

inline void read() {
    cin >> k;
    for (ll i = 0; i < k; i++) {
        char c1, c2;
        cin >> c1 >> c2;
        ll p = c2-'1';
        ll q = c1-'a';
        f[tonum(p, q)] = 1;
    }
}
