#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

typedef unsigned int uint;
#define int ll

typedef pair<int, int> pii;

#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define len(x) (int)(x).size()
#define pb push_back

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

void run();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
    return 0;
}

const int INF = 5e18;

pii from_str(const string &s) {
    return {s[1] - '1', s[0] - 'a'};
}

string to_str(const pii &p) {
    return string() + (char)(p.second + 'a') + (char)(p.first + '1');
}

const vector<pii> dir = {{1, 2}, {-1, 2}, {1, -2}, {-1, -2}, {2, 1}, {-2, 1}, {2, -1}, {-2, -1}};

vector<pii> make_bfs(int x, int y, vector<vector<int>> &fld, const vector<vector<int>> &can_use) {
    if (fld[x][y])
        return {};
    vector<vector<pii>> prv(8, vector<pii>(8, {-1, -1}));
    queue<pii> q;
    pii ans = {-1, -1};
    prv[x][y] = {-2, -2};
    q.push({x, y});
    while (len(q)) {
        auto v = q.front();
        q.pop();
        for (auto &d : dir) {
            int x = v.first + d.first, y = v.second + d.second;
            if (x < 0 || x >= 8 || y < 0 || y >= 8)
                continue;
            if (can_use[x][y])
                continue;
            if (prv[x][y] != pii{-1, -1})
                continue;
            prv[x][y] = v;
            if (fld[x][y]) {
                ans = {x, y};
                break;
            }
            q.push({x, y});
        }
        if (ans != pii(-1, -1))
            break;
    }
    assert(ans != pii(-1, -1));
    vector<pii> res;
    fld[ans.first][ans.second] = 0;
    fld[x][y] = 1;
    while (ans != pii(-2, -2)) {
        res.pb(ans);
        ans = prv[ans.first][ans.second];
    }
    return res;
}

void run() {
    int k;
    cin >> k;
    vector<vector<int>> fld(8, vector<int>(8, 0));
    for (int i = 0; i < k; ++i) {
        string s;
        cin >> s;
        auto x = from_str(s);
        fld[x.first][x.second] = 1;
    }
    vector<vector<int>> can_use(8, vector<int>(8, 0));
    vector<pair<pii, pii>> ans;
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            if (8 * i + j >= k)
                break;
            auto arr = make_bfs(i, j, fld, can_use);
            for (int l = 0; l < len(arr) - 1; ++l) {
                ans.pb({arr[l], arr[l + 1]});
            }
            can_use[i][j] = 1;
        }
    }
    cout << len(ans) << endl;
    for (auto &x : ans) {
        cout << to_str(x.first) << "-" << to_str(x.second) << endl;
    }
}