#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

typedef unsigned int uint;
#define int ll

typedef pair<int, int> pii;

#define F first
#define S second
#define all(x) (x).begin(), (x).end()
#define len(x) (int)(x).size()
#define pb push_back

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

void run();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
    return 0;
}

const int INF = 5e18;

pii from_str(const string &s) {
    return {s[1] - '1', s[0] - 'a'};
}

string to_str(const pii &p) {
    return string() + (char)(p.second + 'a') + (char)(p.first + '1');
}

const vector<pii> dir = {{1, 2}, {-1, 2}, {1, -2}, {-1, -2}, {2, 1}, {-2, 1}, {2, -1}, {-2, -1}};

vector<pii> make_bfs(int x1, int y1, int x2, int y2) {
    vector<vector<pii>> prv(8, vector<pii>(8, {-1, -1}));
    queue<pii> q;
    prv[x2][y2] = {-2, -2};
    q.push({x2, y2});
    while (len(q)) {
        auto v = q.front();
        q.pop();
        for (auto &d : dir) {
            int x = v.first + d.first, y = v.second + d.second;
            if (x < 0 || x >= 8 || y < 0 || y >= 8)
                continue;
            if (prv[x][y] != pii{-1, -1})
                continue;
            prv[x][y] = v;
            if (pii(x, y) == pii(x1, y1))
                break;
            q.push({x, y});
        }
    }
    vector<pii> res;
    pii ans = {x1, y1};
    while (ans != pii(-2, -2)) {
        res.pb(ans);
        ans = prv[ans.first][ans.second];
    }
    return res;
}

vector<pair<pii, pii>> move_by_path(const vector<vector<int>> &fld, vector<pii> path) {
    if (len(path) < 2)
        return {};
    pii last = path.back();
    path.pop_back();
    vector<pair<pii, pii>> ans;
    if (fld[path.back().first][path.back().second]) {
        ans = move_by_path(fld, path);
        ans.pb({last, path.back()});
    } else {
        ans.pb({last, path.back()});
        for (auto &x : move_by_path(fld, path))
            ans.pb(x);
    }
    return ans;
}

void run() {
    int k;
    cin >> k;
    vector<vector<int>> fld(8, vector<int>(8, 0));
    for (int i = 0; i < k; ++i) {
        string s;
        cin >> s;
        auto x = from_str(s);
        fld[x.first][x.second] = 1;
    }
    vector<pair<pii, pii>> res;
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            if (8 * i + j >= k)
                break;
            if (fld[i][j])
                continue;
            pii ans = {-1, -1};
            for (int l1 = i; l1 < 8; ++l1) {
                for (int l2 = 0 + (l1 == i) * j; l2 < 8; ++l2) {
                    if (fld[l1][l2]) {
                        ans = {l1, l2};
                        break;
                    }
                }
                if (ans != pii(-1, -1))
                    break;
            }
            auto path = make_bfs(ans.first, ans.second, i, j);
            reverse(all(path));
            for (auto &x : move_by_path(fld, path))
                res.pb(x);
            fld[ans.first][ans.second] = 0;
            fld[i][j] = 1;
        }
    }
    cout << len(res) << endl;
    for (auto &x : res) {
        cout << to_str(x.first) << "-" << to_str(x.second) << endl;
    }
}
