#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int MAX_N = 100005;

int n, m;
vector<int> g[MAX_N];
bool used[MAX_N];
vector<int> gg[MAX_N];
int cntOut[MAX_N];
int res[MAX_N];
set<pair<int, int>> usedEdges;

void dfs(int u)
{
    used[u] = true;
    for (int v : g[u])
    {
        cntOut[u]++;
        if (!used[v])
        {
            dfs(v);
        }
    }
}

int main()
{
    clock_t start = clock();
    ios::sync_with_stdio(false);
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    if (n == 1)
    {
        cout << "NO" << endl;
        return 0;
    }

    mt19937 randGen(chrono::high_resolution_clock().now().time_since_epoch().count());
    vector<int> r(n);
    for (int i = 0; i < n; i++)
        r[i] = i;
    shuffle(r.begin(), r.end(), randGen);

    int rpos = 0;
    while (float(clock() - start) / CLOCKS_PER_SEC < 0.9f)
    {
        memset(used, 0, sizeof(used));
        for (int i = 0; i < n; i++)
            gg[i].clear();
        memset(cntOut, 0, sizeof(cntOut));
        memset(res, 0, sizeof(res));
        usedEdges.clear();

        if (rpos == n)
            break;
        dfs(r[rpos++]);

        set<pair<int, int>> pq;
        for (int i = 0; i < n; i++)
            pq.emplace(cntOut[i], i);

        int num = n;
        while (!pq.empty())
        {
            auto p = *pq.begin();
            pq.erase(pq.begin());
            res[p.second] = num;
            num--;
            //cout << "! " << p.second << endl;
            for (int v : gg[p.second])
            {
                pq.erase(pair<int, int>(cntOut[v], v));
                cntOut[v]--;
                pq.emplace(cntOut[v], v);
            }
        }

        /*for (int i = 0; i < n; i++)
            if (g[i].empty())
                res[i] = num--;*/

        vector<int> pos;
        for (int i = 0; i < n; i++)
        {
            bool check = true;
            //cout << i << " " << res[i] << endl;
            for (int j : g[i])
            {
                check &= res[i] > res[j];
                //cout << res[j] << endl;
            }
            if (check)
                pos.push_back(i);
        }

        if (pos.size() < 2)
        {
            //cout << "NO" << endl;
            continue;
        }

        cout << "YES" << endl;
        for (int i = 0; i < n; i++)
            cout << res[i] << " ";
        cout << endl;

        int maxVal = 0;
        for (int i : pos)
            maxVal = max(maxVal, res[i]);
        for (int i : pos)
            res[i] = maxVal;

        for (int i = 0; i < n; i++)
            cout << res[i] << " ";
        cout << endl;
        return 0;
    }
    cout << "NO" << endl;
}
