//
// Created by orspc on 09.12.2018.
//
#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;
using ll = long long;
using ui = unsigned int;
typedef pair<set<int>, stack<int>> pii;
const int MAXN = 1e5 + 7;
const ll inf = ll(4e18) + 7;
int n, m;
struct edg {
    int x, y, id;
};

vector<edg> ans;
vector<int> a[MAXN];
pii b[MAXN]; // first - more then need
int et[MAXN];
int deg[MAXN];

bool cmp(int x, int y) {
    return a[x].size() < a[y].size();
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    //freopen("input", "r", stdin);
    int sum = 0;
    cin >> n >> m;
    vector<int> perm(n);
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        for (int j = 0; j < k; j++) {
            int x; cin >> x;
            a[i].push_back(--x);
        }
        deg[i] = k;
        sum += k;
        perm[i] = i;
    }
    sort(perm.begin(), perm.end(), cmp);
    for (int i = 0; i < n; i++) et[i] = sum / n;
    sum %= n;
    for (int i = n - 1; i >= 0; i--) {
        if (sum--) et[perm[i]]++;
        else break;
    }
    for (int i = 0; i < n;i ++) {
        for (int x : a[i]) {
            if (et[i] < deg[i]) {
                b[x].second.push(i);
            }
            if (et[i] > deg[i]) {
                b[x].first.insert(i);
            }
        }
    }
    set<int> less_then_et;
    for (int i = 0; i < n; i++) {
        if (et[i] > a[i].size()) less_then_et.insert(i);
    }
    for (int i = 0; i < m; i++) {
        vector<int> to_delete;
        for (int x : less_then_et) {
            if (b[i].first.count(x)) continue;
            while (b[i].second.size() > 0 && (deg[b[i].second.top()] == et[b[i].second.top()]))
                b[i].second.pop();
            if (!b[i].second.size()) break;
            --deg[b[i].second.top()];
            ++deg[x];
            ans.push_back({b[i].second.top(), x, i});
            b[i].second.pop();
            if (deg[x] == et[x]) to_delete.push_back(x);
        }
        for (auto x : to_delete) less_then_et.erase(x);
    }
    cout << ans.size() << "\n";
    for (auto x : ans) {
        cout << x.x + 1 << " " << x.y + 1 << " " << x.id + 1 << "\n";
    }
    return 0;
}