#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <iostream>
#include <algorithm>
#include <vector> 
#include <set>
#include <queue>

#define mp make_pair

using namespace std;

typedef unsigned long long ull;
typedef long long ll;

const ll INF = ll(5e18);
const ll MOD = (1LL << 32);

template<typename T>
bool uin(T &a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool uax(T &a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

////////////////////////////////////////

int n, m;
vector <pair <int, vector <int>>> v;
vector <vector <int>> g;
set<pair <int, int>> st;

void dfs(int v, vector <int> &d, vector <bool> &used) {
	used[v] = true;
	for (int i = 0; i < g[v].size(); i++) {
		int to = g[v][i];
		if (!used[to]) {
			d[to] = d[v] + 1;
			dfs(to, d, used);
		}
	}
}

void vivans(vector <int> &d, vector <vector <int>> &w) {
	vector <int> ans(n);
	int sum = 1;
	for (int j = 0; j < n; j++) {
		for (int k = 0; k < w[j].size(); k++) {
			ans[w[j][k]] = sum;
			sum++;
		}
	}
	cout << "YES\n";
	for (int j = 0; j < n; j++) {
		cout << ans[j] << " ";
	}
	cout << "\n";
	for (int j = 0; j < n; j++) {
		cout << d[j] << " ";
	}
	exit(0);
}

void solvik() {
	vector <bool> used(n);
	vector <int> d(n);
	vector <vector <int>> w(n);
	d[0] = 1;
	dfs(0, d, used);
	for (int i = 0; i < n; i++) {
		w[d[i] - 1].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		if (w[i].size() > 1) {
			vivans(d, w);
		}
	}
	w.clear();
	used.clear();
	w.resize(n);
	used.resize(n);
	for (int i = 0; i < n; i++) {
		if (g[i].size() < n - 1) {
			used[i] = true;
			for (int j = 0; j < g[i].size(); j++) {
				used[g[i][j]] = true;
			}
			for (int j = 0; j < n; j++) {
				if (!used[j]) {
					d[i] = d[j];
					break;
				}
			}
			for (int j = 0; j < n; j++) {
				w[d[j] - 1].push_back(j);
			}
			vivans(d, w);
		}
	}
	cout << "NO";
}

void solve() {
	vector <int> ans;
	ans.resize(n);
	queue <int> q;
	for (int i = 0; i < n; i++) {
		if (v[i].first == 0) {
			q.push(i);
		}
	}
	int ind = 1;
	while (!q.empty()) {
		int it = q.size();
		for (int i = 0; i < it; i++) {
			int y = q.front();
			ans[q.front()] = ind;
			q.pop();
			for (int j = 0; j < v[y].second.size(); j++) {
				v[v[y].second[j]].first--;
				if (v[v[y].second[j]].first == 0) {
					q.push(v[y].second[j]);
				}
			}
		}
		ind++;
	}
	vector <bool> w(n);
	for (int i = 0; i < n; i++) {
		if (w[ans[i] - 1]) {
			cout << "YES\n";
			for (int j = 0; j < n; j++) {
				cout << j + 1 << " ";
			}
			cout << "\n";
			for (int j = 0; j < n; j++) {
				cout << ans[j] << ' ';
			}
			exit(0);
		}
		else {
			w[ans[i] - 1] = true;
		}
	}
	solvik();
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> m;
	g.resize(n);
	v.resize(n);
	if (n == 1) {
		cout << "NO";
		exit(0);
	}
	int x, y;
	for (int i = 0; i < m; i++) {
		cin >> x >> y;
		x--;
		y--;
		if (y < x) {
			swap(x, y);
		}
		if (st.find(mp(x, y)) == st.end()) {
			st.insert(mp(x, y));
		}
		else {
			continue;
		}
		v[x].second.push_back(y);
		v[y].first++;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	solve();
}