#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <iostream>
#include <algorithm>
#include <vector> 
#include <map>
#include <set>
#include <queue>

#define mp make_pair

using namespace std;

typedef unsigned long long ull;
typedef long long ll;

const ll INF = ll(5e18);
const ll MOD = (1LL << 32);

template<typename T>
bool uin(T &a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool uax(T &a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const int N = (int)1e3 + 7;

////////////////////////////////////////

int m1 = (int)1e9 + 7, m2 = (int)1e9 + 9;
int p1[N], p2[N], p = 31;

void precalc() {
	p1[0] = p2[0] = 1;
	for (int i = 1; i < N; i++) {
		p1[i] = (1LL * p1[i - 1] * p) % m1;
		p2[i] = (1LL * p2[i - 1] * p) % m2;
	}
}

struct Hash {
	int r1, r2;
	Hash() : r1(0), r2(0) {};
	Hash(int r1, int r2) : r1(r1), r2(r2) {};
};

Hash operator + (const Hash &a, const Hash &b) {
	return Hash((a.r1 + b.r1) % m1, (a.r2 + b.r2) % m2);
}

void operator += (Hash &a, const Hash &b) {
	a.r1 = (a.r1 + b.r1) % m1;
	a.r2 = (a.r2 + b.r2) % m2;
}

bool operator == (const Hash &a, const Hash &b) {
	return a.r1 == b.r1 && a.r2 == b.r2;
}

bool operator < (const pair<Hash, int> &a, const pair<Hash, int> &b) {
	if (a.first.r1 == b.first.r1 && a.first.r2 == b.first.r2)
		return a.second < b.second;
	if (a.first.r1 == b.first.r1)
		return a.first.r2 < b.first.r2;
	return a.first.r1 < a.first.r2;
}

Hash get_hash(const string &s) {
	Hash res;
	for (int i = 0; i < s.size(); i++) {
		int val = s[i] - 'a' + 1;
		Hash cur = Hash((1LL * val * p1[i]) % m1, (1LL * val * p2[i]) % m2);
		res += cur;
	}
	return res;
}

int n, ms[N];
map <int, int> m;
string s[N], t[N];
vector <vector<int>> ans;
vector <vector<pair<Hash, int>>> d;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	precalc();
	cin >> n;
	vector <int> all;
	for (int i = 0; i < n; i++) {
		cin >> s[i] >> t[i];
		for (int j = 0; j < t[i].size(); j++)
			ms[i] |= (1 << (t[i][j] - 'a'));
		all.push_back(ms[i]);
	}
	sort(all.begin(), all.end());
	int ind = 0, num = 0;
	while (ind < n) {
		int st = all[ind];
		while (ind < n && st == all[ind])
			ind++;
		m[st] = num++;
	}
	d.resize(num);
	for (int i = 0; i < n; i++) {
		while (s[i].size() != 0 && (ms[i] & (1 << (s[i].back() - 'a'))) != 0)
			s[i].pop_back();
		d[m[ms[i]]].push_back(make_pair(get_hash(s[i]), i));
	}
	for (int i = 0; i < num; i++)
		sort(d[i].begin(), d[i].end());
	vector <int> add;
	for (int i = 0; i < num; i++) {
		int ind = 0, sz = d[i].size();
		while (ind < sz) {
			Hash st = d[i][ind].first;
			while (ind < sz && d[i][ind].first == st)
				add.push_back(d[i][ind].second + 1), ind++;
		}
		ans.push_back(add);
		add.clear();
	}
	cout << ans.size() << endl;
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i].size() << ' ';
		for (int x : ans[i])
			cout << x << ' ';
		cout << endl;
	}
}