#include<bits/stdc++.h>

using namespace std;

void FAST_IO() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    #ifdef _offline
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _offline
}

typedef long long ll;
typedef pair<int, int> pii;

const int MAX_N = 9;

pair<int, int> to_int(pair<char, char> a)
{
    return {a.first - 'a' + 1, a.second - '0'};
}

string to_char(pair<int, int> a)
{
    string k;
    k += (char)(a.first + 'a' - 1);
    k += (char)(a.second + '0');
    return k;
}

int used[MAX_N][MAX_N];

bool ok(int x, int y)
{
    return (x >= 1 && x <= 8 && y >= 1 && y <= 8 && !used[x][y]);
}

int dx[] = {-1, -1, 1, 1, -2, -2, 2, 2};

int dy[] = {-2, 2, -2, 2, -1, 1, -1, 1};

int sz;

void add(vector<vector<string>> &moves, pair<int, int> s, pair<int, int> f)
{
    queue<pair<int, int>> q;
    vector<string> addd;
    q.push(s);
    int curr_used[9][9];
    pair<int, int> pr[9][9];
    fill(&curr_used[0][0], &curr_used[0][0] + 9 * 9, 0);
    fill(&pr[0][0], &pr[0][0] + 9 * 9, pair<int, int>(-1, -1));
    curr_used[s.first][s.second] = 1;
    while (q.size())
    {
        pair<int, int> u = q.front();
        q.pop();
        if (u == f)
        {
            break;
        }
        for (int z = 0; z < 8; z++)
        {
            int inext = dx[z] + u.first;
            int jnext = dy[z] + u.second;
            if (ok(inext, jnext) && curr_used[inext][jnext] == 0)
            {
                curr_used[inext][jnext] = 1;
                pr[inext][jnext] = u;
                q.push({inext, jnext});
            }
        }
    }
    assert(curr_used[f.first][f.second]);
    vector<pair<pair<int, int>, pair<int, int>>> steps;
    pair<int, int> curr = f;
    while (1)
    {
        pair<int, int> nextt = pr[curr.first][curr.second];
        if (nextt == pair<int, int>(-1, -1))
        {
            break;
        }
        steps.push_back({curr, nextt});
        curr = nextt;
    }
    reverse(steps.begin(), steps.end());
    for (int i = (int)(steps.size()) - 1; i >= 0; i--)
    {
        sz++;
        addd.push_back(to_char(steps[i].first) + "-" + to_char(steps[i].second));
    }
    used[s.first][s.second] = 0;
    used[f.first][f.second] = 1;
    moves.push_back(addd);
}

signed main() {
    FAST_IO();
    int n;
    cin >> n;
    vector<pair<int, int>> pos;
    for (int i = 0; i < n; i++)
    {
        pair<char, char> v;
        cin >> v.first >> v.second;
        pos.push_back(to_int(v));
    }
    vector<vector<string>> moves;
    for (int i = 0; i < n; i++)
    {
        used[i % 8 + 1][i / 8 + 1] = 1;
    }
    sort(pos.begin(), pos.end(), [&](pair<int, int> a, pair<int, int> b)
     {
            if (a.second == b.second)
            {
                return a.first > b.first;
            }
            return a.second < b.second;
     });
    for (int y = 8; y >= 1; y--)
    {
        for (int x = 8; x >= 1; x--)
        {
            if (used[x][y])
            {
                add(moves, {x, y}, {pos.back()});
                pos.pop_back();
            }
        }
    }
    cout << sz << endl;
    reverse(moves.begin(), moves.end());
    for (auto &v : moves)
    {
        for (auto out : v)
        {
            cout << out << '\n';
        }
    }
    return 0;
}
