#include<iostream>
#include <utility>
#include <vector>
#include <string>
#include <map>

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pii;

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(0);

    string buf;
    string txt = "";
    bool began = false;

    vector<string> names;
    map<string,string> defs;

    while(getline(cin, buf)) {
        if(buf.substr(0, 7) == "\\begin{")
            began = true;
        if(began) {
            if(buf.substr(0,3) == "\\bi") {
                for(int i = 9; i < buf.size(); i++) {
                    if(buf[i] == '}') {
                        string curname = buf.substr(9, i-9);
                        names.push_back(curname);
                        defs[curname] = buf.substr(i+1);
                        break;
                    }
                }
            }
        } else {
            txt += buf;
        }
    }


    //cout << txt << "\n";
    //for(int i = 0; i < names.size(); i++) {
    //    cout << names[i] << defs[names[i]] << "\n";
    //}

    int off = 0;
    const string pattern = "\\cite{";
    bool inSearch = false;
    string curcite = "";

    vector<string> txtnames;

    for(int i = 0; i < txt.size(); i++) {
        if(!inSearch) {
            if(txt[i] == pattern[off])
                off++;
            else
                off = 0;
            if(off == pattern.size()) {
                inSearch = true;
                off = 0;
                continue;
            }
        } else {
            if(txt[i] == '}') {
                txtnames.push_back(curcite);
                inSearch = false;
                curcite = "";
                continue;
            }
            curcite += txt[i];
        }
    }
    //for(int i = 0; i < txtnames.size(); i++) {
    //    cout << txtnames[i] << "\n";
    //}

    bool correct = true;

    for(int i = 0; i < txtnames.size(); i++) {
        if(txtnames[i] != names[i]) {
            correct = false;
            break;
        }
    }

    if(!correct) {
        cout << "Incorrect\n";
        cout << "\\begin{thebibliography}{99}\n";
        for(int i = 0; i < txtnames.size(); i++) {
            cout << "\\bibitem{" << txtnames[i] << "}" << defs[txtnames[i]] << "\n";
        }
        cout << "\\end{thebibliography}\n";
    } else
        cout << "Correct\n";

    return 0;
}
