import java.io.*;
import java.util.*;

public class B {
    String fileName = "B";

    public static class Item {
        public String key, value;

        public Item(String key, String value) {
            this.key = key;
            this.value = value;
        }
    }

    public Item getItem(String s) {
        String key = null;
        StringBuilder val = new StringBuilder();
        for (String cur : s.split(" ")) {
            if (cur.startsWith("\\bibitem{")) {
                int start = cur.indexOf('{') + 1;
                int end = cur.lastIndexOf('}');
                key = cur.substring(start, end);
            } else {
                val.append(cur);
                val.append(" ");
            }
        }
        if (val.length() > 0)
            val.deleteCharAt(val.length() - 1);
        return new Item(key, val.toString());
    }

    public void solve() throws IOException {
        String tmp = null;
        List<String> bibl = new ArrayList<>();
        Map<String, String> vals = new TreeMap<>();
        List<String> toCheck = new ArrayList<>();
        while ((tmp = br.readLine()) != null) {
            tmp = tmp.trim();
            if (tmp.startsWith("\\bibitem")) {
                Item item = getItem(tmp);
                bibl.add(item.key);
                vals.put(item.key, item.value);
            } else {
                for (String cur : tmp.split(" ")) {
                    if (cur.startsWith("\\cite{")) {
                        int start = cur.indexOf('{') + 1;
                        int end = cur.lastIndexOf('}');
                        String key = cur.substring(start, end);
                        toCheck.add(key);
                    }
                }
            }
        }
        if (toCheck.equals(bibl)) {
            out.println("Correct");
        } else {
            out.println("Incorrect");
            out.println("\\begin{thebibliography}{99}");
            for (int i = 0; i < toCheck.size(); i++) {
                out.print("\\bibitem{");
                out.print(toCheck.get(i));
                out.print("} ");
                out.println(vals.get(toCheck.get(i)));
            }
            out.println("\\end{thebibliography}");
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}