import java.io.*;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class G {
    String fileName = "<name>";

    public static class Pair {
        public BigInteger a, h;

        public Pair(BigInteger a, BigInteger h) {
            this.a = a;
            this.h = h;
        }

        public Pair(Pair p) {
            this(p.a, p.h);
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        Pair[] pairs = new Pair[n];
        int len = 0;
        int[] ans = new int[n];
        Arrays.fill(ans, -1);
        for (int i = 0; i < n; i++) {
            int type = nextInt();
            if (type == 1) {
                pairs[len++] = new Pair(BigInteger.ONE, BigInteger.ONE);
            } else if (type == 2) {
                int ind = nextInt() - 1;
                if (ans[ind] == -1)
                    pairs[ind].a = pairs[ind].a.shiftLeft(1);
            } else if (type == 3) {
                int ind = nextInt() - 1;
                if (ans[ind] == -1)
                    pairs[ind].h = pairs[ind].h.shiftLeft(1);
            } else if (type == 4) {
                pairs[len++] = new Pair(pairs[nextInt() - 1]);
                if (pairs[len - 1].h.compareTo(BigInteger.ZERO) <= 0)
                    ans[len - 1] = i;
            } else {
                int ind1 = nextInt() - 1;
                int ind2 = nextInt() - 1;
                if (ans[ind1] == -1 && ans[ind2] == -1) {
                    pairs[ind1].h = pairs[ind1].h.subtract(pairs[ind2].a);
                    if (pairs[ind1].h.compareTo(BigInteger.ZERO) <= 0)
                        ans[ind1] = i;
                    pairs[ind2].h = pairs[ind2].h.subtract(pairs[ind1].a);
                    if (pairs[ind2].h.compareTo(BigInteger.ZERO) <= 0)
                        ans[ind2] = i;
                }
            }
        }
        out.println(len);
        for (int i = 0; i < len; i++) {
            if (ans[i] != -1)
                out.print(ans[i] + 1);
            else
                out.print(-1);
            out.print(' ');
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        int res = 0;
        int ch = 0;
        while (ch != -1 && !Character.isDigit(ch = br.read())) ;
        do {
            res *= 10;
            res += (int) (ch - '0');
        }
        while (Character.isDigit(ch = br.read()));
        return res;
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new G().run();
    }

}