#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int N = 8;
vector <pair <pair <int, int>, pair <int, int>>> ans;
int f[N * N];
bool horse[N * N];
bool visited[N * N];
vector <int> g[N * N];

int to_num(string s) {
    int i = s[1] - '1', j = s[0] - 'a';
    return i * 8 + j;
}

int to_num2(int i, int j) {
    return i * 8 + j;
}

string to_str(int n) {
    int i = n / 8, j = n % 8;
    string res = "a1";
    res[1] += i;
    res[0] += j;
    return res;
}

bool ok(int i, int j) {
    return (i >= 0 && j >= 0 && i < 8 && j < 8);
}

void build_g() {
    for (int i = 0; i < 8; i++) {
        for (int j = 0; j < 8; j++) {
            for (int c1 = -2; c1 <= 2; c1++) {
                for (int c2 = -2; c2 <= 2; c2++) {
                    if (c1 == 0 || c2 == 0 || (abs(c1) == abs(c2))) continue;
                    if (ok(i + c1, j + c2)) g[to_num2(i, j)].push_back(to_num2(i + c1, j + c2));
                }
            }
        }
    }
}

bool dfs(int pos, int start, vector <int> &res) {
    //cout << pos << endl;
    visited[pos] = 1;
    if (horse[pos] && pos >= start) {
        res.push_back(pos);
        return 1;
    }
    for (int u : g[pos]) {
        if (!visited[u] && u > start) {
            if (dfs(u, start, res)) {
                res.push_back(pos);
                horse[u] = 0;
                horse[pos] = 1;
                return 1;
            }
        }
    }
    return 0;
}

bool dfs2(int pos, int start, vector <int> &res) {
    //cout << pos << endl;
    visited[pos] = 1;
    if (horse[pos]) {
        res.push_back(pos);
        return 1;
    }
    for (int u : g[pos]) {
        //cout << pos
        if (!visited[u] && u < start) {
            if (dfs2(u, start, res)) {
                res.push_back(pos);
                horse[u] = 0;
                horse[pos] = 1;
                return 1;
            }
        }
    }
    return 0;
}

int main() {
    int n;
    cin >> n;
    string s;
    build_g();
    vector <pair <string, string>> ans;
    for (int i = 0; i < 64; i++) horse[i] = 0;
    for (int i = 0; i < n; i++) {
        cin >> s;
        //cout << to_num(s) << endl;
        horse[to_num(s)] = 1;
    }
    //horse[46] = 0;
    //horse[46] = 0;
    if (n <= 32) {
        for (int i = 0; i < n; i++) {
            vector <int> now;
            for (int j = 0; j < 64; j++) visited[j] = 0;
            if (!dfs(i, i, now)) return -1;
            //cout << "kek" << endl;
            //for (int elem : now) cout << elem << ' ';
            //cout << endl;
            //reverse(now.begin(), now.end());
            //cout << "@@@" << now.size() << endl;
            for (int j = 0; j + 1 < (int) now.size(); j++) {
                ans.push_back({to_str(now[j]), to_str(now[j + 1])});
            }
            //cout << now.size() << "!@!!" << endl;
        }
        cout << ans.size() << endl;
        for (auto elem : ans) {
            cout << elem.first << "-" << elem.second << endl;
        }
        return 0;
    } else {
        for (int i = 0; i < 64; i++) horse[i] = !horse[i];
        int k = 64;
        for (int i = 0; i < 64 - n; i++) {
            //cout << i << endl;
            k--;
            for (int j = 0; j < 64; j++) visited[j] = 0;
            vector <int> now;
            if (!dfs2(k, k, now)) return -1;
            //reverse(now.begin(), now.end());
            for (int j = 0; j + 1 < (int) now.size(); j++) {
                ans.push_back({to_str(now[j + 1]), to_str(now[j])});
            }
            //for (int elem : now) ans.push_back(elem);
        }
        cout << ans.size() << endl;
        for (auto elem : ans) {
            cout << elem.first << " " << elem.second << endl;
        }
        return 0;
    }
}
