//#include <bits/stdc++.h>

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int SZ = 1e5 + 10;

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
}

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
#define sz(a) int(a.size())
#define ll long long

int n, m;
vector<int> graph[SZ];
set<int> gr[SZ];

bool used[SZ];

void clear_used()
{
	for (int i = 1; i <= n; i++)
		used[i] = false;
}

void get_comp(int v, vector<int> &vect)
{
	used[v] = true;
	vect.push_back(v);
	for (auto to : graph[v]) {
		if (!used[to])
			get_comp(to, vect);
	}
}

void dfs_for_build(int v)
{
	used[v] = true;
	for (auto to : graph[v]) {
		if (used[to]) {
			gr[v].erase(to);
			gr[to].insert(v);
		}
		else {
			gr[v].insert(to);
			gr[to].erase(v);
			dfs_for_build(to);
		}
	}
}

vector<int> vect;

pair<int, int> build_graph(int v)
{
	vect.clear();
	clear_used();
	get_comp(v, vect);
	for (int x : vect) {
		if (graph[x].size() < vect.size() - 1) {
			v = x;
			break;
		}
	}
	clear_used();
	dfs_for_build(v);
	if (graph[v].size() == vect.size() - 1)
		return { 0, 0 };
	int u = -1;
	for (auto x : vect) {
		if (!gr[v].count(x) && v != x) {
			u = x;
			break;
		}
	}
	for (auto x : graph[u]) {
		gr[x].erase(u);
		gr[u].insert(x);
	}
	return { v, u };
}

vector<int> top;
set<int> gr2[SZ];

void get_top(int v)
{
	used[v] = true;
	for (auto to : gr2[v]) {
		if (!used[to])
			get_top(to);
	}
	top.push_back(v);
}

int filled = 0;
int arr1[SZ], arr2[SZ];

void fill_1()
{
	for (auto x : top)
		arr1[x] = ++filled;
}

int fill_2()
{
	int max_now = 0;
	for (int x : top) {
		int now = 0;
		for (auto to : gr[x])
			now = max(now, arr2[to]);
		arr2[x] = now + 1;
		max_now = max(max_now, arr2[x]);
	}
	return max_now;
}

bool action(int v)
{
	pair<int, int> now = build_graph(v);
	
	for (int v = 1; v <= n; v++) {
		for (auto to : gr[v]) {
			gr2[to].insert(v);
		}
	}

	clear_used();
	top.clear();
	for (auto x : vect) {
		if (!used[x])
			get_top(x);
	}
	reverse(top.begin(), top.end());
	/*
	for (int x : vect) {
	cout << x << " : ";
	for (auto y : gr[x])
	cout << y << ' ';
	cout << endl;
	}
	for (auto x : top)
	cout << x << ' ';
	cout << endl;
	*/
	fill_1();
	int M = fill_2();
	if (now.first == 0)
		return false;
	arr2[now.first] = arr2[now.second] = M;
	return true;
}

signed main() {
	fast();
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}
	int cnt = 0;
	bool ans = false;
	for (int i = 1; i <= n; i++) {
		if (!used[i]) {
			cnt++;
			ans = max(ans, action(i));
		}
	}
	if (cnt == 1 && ans == false) {
		cout << "NO";
		return 0;
	}
	for (int v = 1; v <= n; v++) {
		for (auto u : graph[v]) {
			if (arr1[v] == arr1[u] || arr2[v] == arr2[u]) {
				cout << "NO";
				return 0;
			}
			if (arr1[v] < arr1[u] && arr2[v] > arr2[u]) {
				cout << "NO";
				return 0;
			}
			if (arr1[v] > arr1[u] && arr2[v] < arr2[u]) {
				cout << "NO";
				return 0;
			}
		}
	}
	set<int> was;
	bool was_ans = false;
	for (int v = 1; v <= n; v++) {
		if (was.count(arr2[v]))
			was_ans = true;
		was.insert(arr2[v]);
	}
	if (!was_ans) {
		cout << "NO";
		return 0;
	}
	was.clear();
	for (int v = 1; v <= n; v++) {
		if (was.count(arr1[v])) {
			cout << "NO";
			return 0;
		}
		was.insert(arr1[v]);
	}
	cout << "YES\n";
	for (int i = 1; i <= n; i++)
		cout << arr1[i] << ' ';
	cout << endl;
	for (int i = 1; i <= n; i++)
		cout << arr2[i] << ' ';
	return 0;
}