#include <bits/stdc++.h>

using namespace std;

const int N = 8;

bool ch[N][N];
bool have[N][N];

vector <pair <pair <int, int>, pair <int, int> > > ans;

const int INF = 1e9 + 7;

int dist[N][N];
pair <int, int> par[N][N];

bool check(int x, int y) {
	return 0 <= x && x < N && 0 <= y && y < N;
}	

vector <pair <int, int> > v = {{1, 2}, {1, -2}, {-1, 2}, {-1, -2}, {2, -1}, {2, 1}, {-2, 1}, {-2, -1} };

void bfs(int x, int y) {
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            dist[i][j] = INF;
            par[i][j] = {-1, -1};
        }	
    }	
    dist[x][y] = 0;
    queue <pair <int, int> > q;
    q.push({x, y});
    while (q.size()) {
    	auto u = q.front();
    	q.pop();
    	for (auto d : v) {
    	    int dx = d.first;
    	    int dy = d.second;
    	    if (check(u.first + dx, u.second + dy) && dist[u.first][u.second] + 1 < dist[u.first + dx][u.second + dy]) {
    	        dist[u.first + dx][u.second + dy] = dist[u.first][u.second] + 1;
    	        par[u.first + dx][u.second + dy] = u;
    	        q.push({u.first + dx, u.second + dy});
    	    }	
    	}	
    }	
}	

void f(int x1, int y1, int x2, int y2) {
	ans.push_back({{x1, y1}, {x2, y2}});
	have[x1][y1] = 0;
	have[x2][y2] = 1;
}	

void go(int cx, int cy, int x, int y) {
	vector <pair <int, int> > v;
	while (1) {
	    v.push_back({cx, cy});
	    if (cx == x && cy == y) {
	        break;
	    }	
	    auto u = par[cx][cy];
	    cx = u.first; cy = u.second;
	}	
	while (v.size() != 1) {
	    int pos = -1;
	    for (int i = (int)v.size() - 1; i >= 0; --i) {
	        if (have[v[i].first][v[i].second]) {
	            pos = i;
	            break;
	        }	
	    }	
	    for (int i = pos; i + 1 < v.size(); ++i) {
	        f(v[i].first, v[i].second, v[i + 1].first, v[i + 1].second);
	    }	
		while (v.size() > pos + 1) {
		    v.pop_back();
		}	
	}	
}	

void kek(int x, int y) {
	if (have[x][y]) {
	    ch[x][y] = 0;
	    return;
	}	
    bfs(x, y);
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
         	if (have[i][j] && ch[i][j]) {
				go(i, j, x, y);
				ch[x][y] = 0;
				return;
         	}	
        }
    }
}	

signed main() {
	#ifdef HOME
		freopen("input.txt", "r", stdin);
	#endif

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	for (int i = 0; i < N; ++i) {
	    for (int j = 0; j < N; ++j) {
	        ch[i][j] = 1;
	    }	
	}	

	int n;
	cin >> n;
	for (int i = 0; i < N; ++i) {
	    for (int j = 0; j < N; ++j) {
	       	char c;
	       	cin >> c;
	       	int t;
	       	cin >> t;
	       	have[c - 'a'][t - 1] = 1;
	    }	
	}	

	for (int i = 0; i < n; ++i) {
	    int x = i / 8;
	    int y = i % 8;
	    swap(x, y);
	    kek(x, y);
	}	

	if (ans.size() > 1500) {
   	 	exit(1);
   	}

	cout << ans.size() << '\n';
	for (auto e : ans) {
	    cout << (char)('a' + e.first.first) << 1 + e.first.second << '-' << (char)('a' + e.second.first) << 1 + e.second.second << '\n';
	}	

    return 0;
}	