#include <iostream>
#include <algorithm>
#include <set>
#include <climits>
#include <vector>

using namespace std;

const int N = 10000007;
const long long mod = 1LL << 32LL;

int n;
long long l, r;
long long x, y, z;

long long a[N], b[N];

void solve()
{
    cin >> n >> l >> r >> x >> y >> z >> b[1] >> b[2];
    //scanf("%d %I64d %I64d %I64d %I64d %I64d %I64d %I64d", &n, &l, &r, &x, &y, &z, b+1, b+2);
    if (n == 1) {
        cout << "IMPOSSIBLE" << endl;
        return;
    }

    a[1] = (b[1] % (r - l + 1)) + l;
    a[2] = (b[2] % (r - l + 1)) + l;
    for (int i = 3; i <= n; i++) {
        b[i] = (b[i - 2]*x + b[i - 1]*y + z) % mod;
        a[i] = (b[i] % (r - l + 1)) + l;
    }

    set<long long> s, d;
    long long ans = INT_MAX;
    for (int i = 1; i <= n; ++i)
    {
        if (a[i] <= 0)
        {
            set<long long>::iterator it = s.lower_bound(a[i]);
            if (it != s.begin())
            {
                --it;
                if ((*it) < a[i])
                    ans = min(ans, a[i] * (*it));
            }
            s.insert(a[i]);
        }
        else
        {
            if (!s.empty())
            {
                ans = min(ans, a[i] * (*s.begin()));
            }
            if (!d.empty())
            {
                if (a[i] > (*d.begin()))
                    ans = min(ans, a[i] * (*d.begin()));
            }
            d.insert(a[i]);
        }
    }
    if (ans != INT_MAX)
        cout << ans << endl;
    else
        cout << "IMPOSSIBLE" << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);

    int t;
    cin >> t;

    while (t--)
        solve();

    return 0;
}
